unit dibujos;

{$mode objfpc}{$H+}

// Por hacer:
// * Revisar base de datos
// Lista de:
//  "    " Primarias, Secundarias
// * Revolucion solar
// * Estructurarlo

interface

uses
  // ftfont,
  VB, // Grids,
  Process, ExtCtrls, // RTTICtrls,
  Graphics, GraphType, IntfGraphics, LCLType, LCLProc, LCLIntf, Interfaces,
  FPimage, ftfont, FPWritePNG, FPWriteJPEG, FPCanvas, Forms,
  Classes, SysUtils, Math;
var
  menores: boolean;

type
  LongPl = array[0..1, 0..26] of double;
  DeclinPl= array[0..26] of double;
  Vl = array [0..1, 0..10] of double;
  lp = array[0..12] of single;
  aspectado = array[0..29, 0..29] of integer;

procedure dibujaCarta(Rtr, ancho, alto: integer; longip: LongPl;
  vel: Vl; Tv: Timage; datos: string; imprimir: boolean; sb: TImage);
function calcula_aspecto(LongP: LongPl; planeta1, planeta2: integer;
  sinas: boolean; orbe: single): integer;
function calcula_asparal(DeclP: DeclinPl; planeta1, planeta2: integer;
  sinas: boolean; orbe: single): integer;
function en360(x: single): single;
procedure Dibuja_Planeta(imprimir: boolean; dib, sb: Timage; x, y: longint;
  fig, tam: integer);
procedure simboloAspecto(Tv:TImage;xp,yp,tam,distancia:integer;sc:single);

implementation

function rad(x: single): single;
begin
  rad := x * 1.74532925199433E-02;
end;

function en360(x: single): single;
var
  re: single;
begin
  re := (x - (Trunc(x / 360.0) * 360.0));
  if re < 0 then
    re := 360 + re;
  en360 := re;
end;

//procedure Circle(dib: TFPImageCanvas; X,Y,R:single);
procedure Circle(dib: Timage; X, Y, R: single);
begin
  // dib.EllipseC(Trunc(X),Trunc(Y),Trunc(R),Trunc(R));
  dib.Canvas.EllipseC(Trunc(X), Trunc(Y), Round(R), Round(R));
end;

procedure colorPincel(imprimir: boolean; Tv: Timage);
begin
  if imprimir then
  begin
    Tv.Canvas.Pen.Color := RGBToColor(0, 0, 0);
  end
  else
  begin
    Tv.Canvas.Pen.Color := RGBToColor(255, 255, 255);
  end;
end;

procedure colorPincel2(imprimir: boolean; Tv: Timage);
begin
  if imprimir then
  begin
    Tv.Canvas.Pen.Color := RGBToColor(255, 255, 255);
  end
  else
  begin
    Tv.Canvas.Pen.Color := RGBToColor(60,90,120);
  end;
end;

function calcula_asparal(DeclP: DeclinPl; planeta1, planeta2: integer;
  sinas: boolean; orbe: single): integer;
var
  Rtr, Aspecto: integer;
  distancia: single;
begin
  {
  Rtr := 0;
  if sinas then
    Rtr := 1;
  }
  distancia := abs(abs(DeclP[planeta1]) - abs(DeclP[planeta2]));
  if (distancia < (orbe)) then begin
    if ((DeclP[planeta1] > 0) and (DeclP[planeta2] > 0)) or
       ((DeclP[planeta1] < 0) and (DeclP[planeta2] < 0)) then begin
         Aspecto := 999; // Paralelo
       end
       else begin
         Aspecto := 909; // Antiparalelo
       end;
  end
  else begin
    Aspecto := -1;
  end;
  calcula_asparal:= Aspecto;
end;

function calcula_aspecto(LongP: LongPl; planeta1, planeta2: integer;
  sinas: boolean; orbe: single): integer;
var
  i, apt, Rtr, Aspecto: integer;
  sLinea: string;
  orb1, orb2, orb3, distancia: single;
  asp, dt, da1, da2 : array of string;
const nbPlanetas ='Sol,Lun,Mer,Ven,Mar,Jup,Sat,Ura,Nep,Plu,Nod,Asc';
const nAspectos= '0,30,45,60,72,90,120,135,144,150,180';
begin
  Rtr := 0;
  if sinas then Rtr := 1;
  distancia := LongP[0, planeta1] - LongP[Rtr, planeta2];
  if (distancia < 0) then
    distancia := distancia + 360;
  if (distancia > 180) then
    distancia := 360 - distancia;
  if (planeta2 > 11) then planeta2:= 11; // Asc, casas y MC tienen el mismo orbe
  if (planeta1 > 11) then planeta1:= 11;
  dt:= vbSplit(nbPlanetas,',');
  sLinea := readINI('opciones.ini', 'orbes', dt[planeta1], '0');
  da1 := vbSplit(sLinea,',');
  sLinea := readINI('opciones.ini', 'orbes', dt[planeta2], '0');
  da2 := vbSplit(sLinea,',');
  asp := vbSplit(nAspectos,',');

  Aspecto := -1;
  for i:=0 to 10 do begin
     orb1:=vbVal(da1[i]);
     orb2:=vbVal(da2[i]);
     orbe:=(orb1 + orb2) / 2;
     if (i = 0) and (distancia < (orbe)) then begin // Conjuncion
       Aspecto := 0;
       Break;
     end
     else begin
       apt:= vbVal(asp[i]);
       if (menores = false) and (apt <> 45) and (apt <> 135) and (apt <> 72) and (apt <> 144) then begin
         if ((apt - (orbe)) < distancia) and (distancia < (apt + (orbe))) then begin
           Aspecto := apt;
           Break;
         end;
       end
       else if (menores = true) then begin
         if ((apt - (orbe)) < distancia) and (distancia < (apt + (orbe))) then begin
           Aspecto := apt;
           Break;
         end;
       end; // menores
     end;
  end;
  calcula_aspecto:= Aspecto;
end;

//procedure DibujaGrado(dib: TFPImageCanvas; IniRad: longint; sc: single; cx, cy: longint);
procedure DibujaGrado(dib: Timage; IniRad: longint; sc: single;
  cx, cy: longint; Rtr: integer);

var
  sch, LR, r1, r2, r3, r4, r5: single;
  i, cnt: integer;
begin
  sch := 680 * sc;
  r1 := sch / (1.98 * 1.25);
  r2 := sch / (2.51 * 1.25);
  r3 := r1 * 0.84;
  r4 := r1 * 0.82; //sch / (2.4 * 0.985 * 1.25);
  r5 := r1 * 0.805;

  // dib.Brush.Style:=bsClear; //bsDiagCross; //bsSolid;
  // Para que los circulos salgan transparentes en lugar de rellenos:
  dib.Canvas.Brush.Style := BsClear;

  //De interior a exterior:
  Circle(dib, cx, cy, r1 * 0.58); // aspectos
  // Circle(dib, cx, cy, r1 * 0.63);
  Circle(dib, cx, cy, r1 * 0.79);
  Circle(dib, cx, cy, r1 * 0.81); // grados
  Circle(dib, cx, cy, r1 * 0.84);
  Circle(dib, cx, cy, r1);

  // sn = exterior()
  // if (InStr(sn, 'N') = 0) then Circle(dib, cx, cy, r1);

  cnt := -1;
  for i := IniRad to (IniRad + 360) do
  begin
    cnt := cnt + 1;
    if ((cnt mod 30) = 0) then
    begin
      LR := r1;
    end
    else
    if ((cnt mod 10) = 0) then
    begin
      LR := r3; // + 9; // 10 grados
    end
    else
    if ((cnt mod 5) = 0) then
    begin
      LR := r4; // 5 grados
    end
    else
    begin
      LR := r5; // 1 grado
    end;
    // dib.Line(Trunc(cx  + (LR * Sin(rad(i)))), Trunc(cy  + (LR * Cos(rad(i)))), Trunc(cx  + (r2 * Sin(rad(i)))), Trunc(cy  + (r2 * Cos(rad(i)))) );
    dib.Canvas.Line(Trunc(cx + (LR * Sin(rad(i)))), Trunc(cy + (LR * Cos(rad(i)))),
      Trunc(cx + (r2 * Sin(rad(i)))), Trunc(cy + (r2 * Cos(rad(i)))));
  end; // for

  if Rtr = 1 then
  begin
    Circle(dib, cx, cy, r1 * 1.015);  // Interior
    Circle(dib, cx, cy, r1 * 1.030);
    Circle(dib, cx, cy, r1 * 1.2);  // Exterior
    cnt := -1;
    for i := IniRad to (IniRad + 360) do
    begin
      cnt := cnt + 1;
      if ((cnt mod 10) = 0) then
      begin
        LR := r1 * 1.030; // + 9; // 10 grados
      end
      else
      begin
        LR := r1 * 1.014; // 1 grado
      end;
      // dib.Line(Trunc(cx  + (LR * Sin(rad(i)))), Trunc(cy  + (LR * Cos(rad(i)))), Trunc(cx  + (r2 * Sin(rad(i)))), Trunc(cy  + (r2 * Cos(rad(i)))) );
      dib.Canvas.Line(Trunc(cx + (LR * Sin(rad(i)))),
        Trunc(cy + (LR * Cos(rad(i)))), Trunc(cx + (r1 * Sin(rad(i)))),
        Trunc(cy + (r1 * Cos(rad(i)))));
    end; // for
  end;

end;

// procedure Dibuja_Signo(ff:boolean; dib, sb: TFPImageCanvas; x, y: longint; fig: integer);
procedure Dibuja_Signo(ff: boolean; dib, sb: Timage; x, y: longint; fig, tam: integer);
var
  i, x2, y2, px, py: integer;
  d, s: string;
  Dt: array of string;
begin
  s := 'n,aries,tauro,geminis,cancer,leo,virgo,libra,escorpio,sagitario,capricornio,acuario,piscis';
  Dt := vbSplit(s, ',');
  d := Dt[fig] + '.png';
  // sb.Picture.LoadFromFile(d);
  px := x + tam;
  py := Round(y + (tam * 1.2));
  x2 := x;
  y2 := y;
  // y:= y - Trunc(tam * 1.007);
  // dib.Picture.Bitmap.Canvas.StretchDraw(Rect(x, y, px, py),sb.Picture.Bitmap);
  dib.Canvas.Pen.Width := Trunc(tam / 6);
  case fig of
    1:
    begin
      x := x - Trunc(tam * 0.2);
      y := y + Trunc(tam * 0.2);
      dib.Canvas.Pen.Color := RGBToColor(190, 16, 64);
      dib.Canvas.Arc(x, y, x + Trunc(tam / 2), y + trunc(tam / 2), 1 * 16, 210 * 16);
      dib.Canvas.Arc(x + Trunc(tam / 2), y, x + Trunc(tam), y +
        trunc(tam / 2), -30 * 16, 180 * 16);
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 3), x +
        Trunc(tam / 2), y + Trunc(tam / 1.07));
    end;
    2:
    begin
      x := x - Trunc(tam * 0.2);
      y := y + Trunc(tam * 0.3);
      dib.Canvas.Pen.Color := RGBToColor(64, 190, 16);
      Circle(dib, x + (tam / 2), y + (tam / 2), tam / 2.1);
      dib.Canvas.Arc(x + Trunc(tam / 7), y - Trunc(tam * 1.11), x +
        Trunc(tam / 1.1), y + Trunc(tam / 18), -150 * 16, 120 * 16);
    end;
    3:
    begin
      x := x - Trunc(tam * 0.3);
      dib.Canvas.Pen.Color := RGBToColor(127, 127, 0);
      dib.Canvas.Arc(x, y - Trunc(tam / 1.11), x + Trunc(tam),
        y + Trunc(tam / 2.5), -145 * 16, 110 * 16);
      dib.Canvas.Arc(x, y + Trunc(tam), x + Trunc(tam), y +
        Trunc(tam * 2), 35 * 16, 110 * 16);
      dib.Canvas.Line(x + Trunc(tam / 4), y + Trunc(tam / 3), x +
        Trunc(tam / 4), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam / 1.37), y + Trunc(tam / 3), x +
        Trunc(tam / 1.37), y + Trunc(tam));
    end;
    4:
    begin
      x := x - Trunc(tam * 0.2);
      y := y - Trunc(tam * 0.2);
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x, y + Trunc(tam / 3.5), x + Trunc(tam), y +
        Trunc(tam), 30 * 16, 120 * 16);
      Circle(dib, x + (tam / 6), y + (tam / 1.5), tam / 4);
      dib.Canvas.Arc(x, y + Trunc(tam / 2), x + Trunc(tam), y +
        Trunc(tam * 1.33), -150 * 16, 120 * 16);
      Circle(dib, x + (tam / 1.15), y + (tam / 1.15), tam / 4);
    end;
    5:
    begin
      x := x - Trunc(tam * 0.1);
      y := y + Trunc(tam * 0.1);
      dib.Canvas.Pen.Color := RGBToColor(190, 64, 16);
      dib.Canvas.Arc(x, y + Trunc(tam / 12), x + Trunc(tam / 1.3),
        y + Trunc(tam), -30 * 16, 180 * 16);
      Circle(dib, x + (tam / 9), y + (tam / 1.5), tam / 3.3);
      dib.Canvas.Arc(x + Trunc(tam / 1.5), y - Trunc(tam / 3600), x +
        Trunc(tam), y + Trunc(tam), -150 * 16, 120 * 16);
    end;
    6:
    begin
      x := x - Trunc(tam * 0.3);
      dib.Canvas.Pen.Color := RGBToColor(90, 180, 0);
      dib.Canvas.Arc(x, y + Trunc(tam / 7), x + Trunc(tam), y +
        Trunc(tam / 1.15), 20 * 16, 150 * 16); // grande
      dib.Canvas.Line(x + Trunc(tam / 4.5), y + Trunc(tam / 3), x +
        Trunc(tam / 4.5), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam / 1.6), y + Trunc(tam / 4), x +
        Trunc(tam / 1.6), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam), y + Trunc(tam / 3), x +
        Trunc(tam), y + Trunc(tam));
      dib.Canvas.Arc(x + Trunc(tam), y + Trunc(tam / 6), x +
        Trunc(tam * 1.3), y + Trunc(tam / 1.7), -150 * 16, 290 * 16);
      // Rabillo: tam, -150*16,120*16
      //dib.Canvas.Arc(x + Trunc(tam), y + Trunc(tam / 2.5), x +
      //  Trunc(tam * 1.25), y + Trunc(tam), -190 * 16, 120 * 16);
      dib.Canvas.Line(x + Trunc(tam), y + Trunc(tam / 2), x +
        Trunc(tam * 1.3), y + Trunc(tam));
    end;
    7:
    begin
      x := x - Trunc(tam * 0.2);
      dib.Canvas.Pen.Color := RGBToColor(127, 127, 0);
      dib.Canvas.Arc(x, y + Trunc(tam / 64), x + Trunc(tam / 1.2),
        y + Trunc(tam / 1.15), -30 * 16, 240 * 16);
      dib.Canvas.Line(x - Trunc(tam / 8), y + Trunc(tam / 1.5), x +
        Trunc(tam / 12), y + Trunc(tam / 1.5)); // izq
      dib.Canvas.Line(x + Trunc(tam / 1.05), y + Trunc(tam / 1.5), x +
        Trunc(tam / 1.29), y + Trunc(tam / 1.5)); // der
      dib.Canvas.Line(x - Trunc(tam / 8), y + Trunc(tam/1.1), x +
        Trunc(tam/1.05), y + Trunc(tam/1.1));
    end;
    8:
    begin
      x := x - Trunc(tam * 0.3);
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x, y + Trunc(tam / 7), x + Trunc(tam), y +
        Trunc(tam / 1.15), 20 * 16, 150 * 16); // grande
      dib.Canvas.Line(x + Trunc(tam / 4.5), y + Trunc(tam / 3), x +
        Trunc(tam / 4.5), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam / 1.8), y + Trunc(tam / 4), x +
        Trunc(tam / 1.8), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam/1.1), y + Trunc(tam / 3), x +
        Trunc(tam/1.1), y + Trunc(tam));
      dib.Canvas.Arc(x + Trunc(tam / 1.1), y + Trunc(tam / 1.5), x +
        Trunc(tam * 1.25), y + Trunc(tam), -150 * 16, 120 * 16);
    end;
    9:
    begin
      x := x - Trunc(tam * 0.2);
      dib.Canvas.Pen.Color := RGBToColor(210, 60, 120);
      dib.Canvas.Line(x + Trunc(tam / 1.5), y + Trunc(tam / 12), x +
        Trunc(tam / 3), y + Trunc(tam * 1.25));
      dib.Canvas.Line(x + Trunc(tam / 1.29), y + Trunc(tam), x +
        Trunc(tam / 12), y + Trunc(tam));
      // Flecha
      dib.Canvas.Line(x + Trunc(tam / 1.5), y + Trunc(tam / 12), x +
        Trunc(tam / 2.9), y + Trunc(tam / 2.25));
      dib.Canvas.Line(x + Trunc(tam / 1.29), y + Trunc(tam / 2.25),
        x + Trunc(tam / 1.5), y + Trunc(tam / 12));
    end;
    10:
    begin
      x := x - Trunc(tam * 0.7);
      dib.Canvas.Pen.Color := RGBToColor(90, 180, 0);
      dib.Canvas.Arc(x + Trunc(tam), y + Trunc(tam / 2), x +
        Trunc(tam * 1.3), y + Trunc(tam * 1.05), -500 * 16, 200 * 16);
      dib.Canvas.Line(x + Trunc(tam), y + Trunc(tam / 3), x +
        Trunc(tam / 1.3), y + Trunc(tam));
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 3), x +
        Trunc(tam / 1.3), y + Trunc(tam));
      dib.Canvas.Arc(x + Trunc(tam), y + Trunc(tam / 6), x +
        Trunc(tam * 1.3), y + Trunc(tam / 1.7), -150 * 16, 278 * 16);// arriba
    end;
    11:
    begin
      x := x - Trunc(tam * 0.3);
      y := y + Trunc(tam * 0.3);
      dib.Canvas.Pen.Color := RGBToColor(127, 127, 0);
      dib.Canvas.Line(x + Trunc(tam), y + Trunc(tam / 18), x +
        Trunc(tam / 1.3), y + Trunc(tam / 4));
      dib.Canvas.LineTo(x + Trunc(tam / 2), y + Trunc(tam / 18));
      dib.Canvas.LineTo(x + Trunc(tam / 4), y + Trunc(tam / 4));
      dib.Canvas.LineTo(x + Trunc(tam / 64), y + Trunc(tam / 18));
      //  ---------
      dib.Canvas.Line(x + Trunc(tam), y + Trunc(tam / 2.5), x +
        Trunc(tam / 1.3), y + Trunc(tam / 1.5));
      dib.Canvas.LineTo(x + Trunc(tam / 2), y + Trunc(tam / 2.5));
      dib.Canvas.LineTo(x + Trunc(tam / 4), y + Trunc(tam / 1.5));
      dib.Canvas.LineTo(x + Trunc(tam / 64), y + Trunc(tam / 2.5));
    end;
    12:
    begin
      y := y + Trunc(tam * 0.1);
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x - Trunc(tam / 2), y + Trunc(tam / 9), x +
        Trunc(tam / 6), y + Trunc(tam), -110 * 16, 210 * 16); // -90,180
      //         dib.Canvas.Arc(x + Trunc(tam/2) , y + Trunc(tam/9), x + Trunc(tam*1.3), y + Trunc(tam), 270 * 16, -180 * 16);
      dib.Canvas.Arc(x + Trunc(tam / 2), y + Trunc(tam / 9), x +
        Trunc(tam * 1.3), y + Trunc(tam), 90 * 16, 180 * 16);
      dib.Canvas.Line(x - Trunc(tam / 6), y + Trunc(tam / 1.75), x +
        Trunc(tam / 1.3), y + Trunc(tam / 1.75)); // 2
    end;
  end;
  y := y2;
end;

//procedure Dibuja_Planeta(dib: TFPImageCanvas; x, y: longint; fig:integer);
procedure Dibuja_Planeta(imprimir: boolean; dib, sb: Timage; x, y: longint;
  fig, tam: integer);
var
  px, py: integer;
  d, s: string;
  Dt: array of string;

begin
      {s:='sol,luna,mercurio,venus,marte,jupiter,saturno,urano,neptuno,pluton,nodo,As,Mc';
      Dt:= vbSplit(s,',');
      y:= y + Round(tam * 0.25);
      if fig < 11 then begin
        d:= Dt[fig] + '.png';
        sb.Picture.LoadFromFile(d);
        px:= x + tam;
        py:= y + tam;
        dib.Picture.Bitmap.Canvas.StretchDraw(Rect(x, y, px, py),sb.Picture.Bitmap);
      end
      else begin
        if fig=20 then fig:=12;
        dib.Canvas.Font.Name:='monospace';
        dib.Canvas.Font.Size:= Round(tam * 0.75);
        if imprimir then begin
          dib.Canvas.Font.Color:=RGBToColor(0,0,0);
        end
        else begin
          dib.Canvas.Font.Color:=RGBToColor(255, 255, 255);
        end;
        dib.Canvas.TextOut(x, y, Dt[fig]);
      end;}
  dib.Canvas.Pen.Width := Trunc(tam / 6);
  y := y + Trunc(tam / 2.7);
  x := x + Trunc(tam / 9);
  case fig of
    0:
    begin // Sol
      dib.Canvas.Pen.Color := RGBToColor(190, 64, 16);
      Circle(dib, x + (tam / 2), y + (tam / 2), tam / 2);
      Circle(dib, x + (tam / 2), y + (tam / 2), tam / 20);
    end;
    1:
    begin // Luna
      x := x + Trunc(tam / 5);
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x - Trunc(tam / 2), y + Trunc(tam / 9), x +
        Trunc(tam / 6), y + Trunc(tam), -60 * 16, 125 * 16);
      dib.Canvas.Arc(x - Trunc(tam / 3), y + Trunc(tam / 9), x +
        Trunc(tam / 1.75), y + Trunc(tam), -110 * 16, 230 * 16); // izq.
    end;
    2:
    begin // Mercurio
      y := y + Trunc(tam / 6);
      dib.Canvas.Pen.Color := RGBToColor(127, 127, 0);
      Circle(dib, x + (tam / 2), y + (tam / 4.5), tam / 3.45);
      dib.Canvas.Arc(x + Trunc(tam / 5), y - Trunc(tam * 1.1), x +
        Trunc(tam / 1.25), y - Trunc(tam / 9), -135 * 16, 90 * 16);// -125, 70
      dib.Canvas.Line(x + Trunc(tam / 3.7), y + Trunc(tam / 1.29),
        x + Trunc(tam / 1.39), y + Trunc(tam / 1.29));
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 1.9), x +
        Trunc(tam / 2), y + Trunc(tam/1.1));

    end;
    3:
    begin // Venus
      dib.Canvas.Pen.Color := RGBToColor(16, 150, 80);
      Circle(dib, x + (tam / 2), y + (tam / 3.3), tam / 3.2);
      dib.Canvas.Line(x + Trunc(tam / 3.7), y + Trunc(tam / 1.17),
        x + Trunc(tam / 1.39), y + Trunc(tam / 1.17));
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 1.6), x +
        Trunc(tam / 2), y + Trunc(tam));
    end;
    4:
    begin // Marte
      x := x + Trunc(tam / 5);
      y := y + Trunc(tam / 5);
      dib.Canvas.Pen.Color := RGBToColor(210, 16, 16);
      Circle(dib, x + (tam / 9), y + (tam / 2), tam / 3.2);
      dib.Canvas.Line(x + Trunc(tam / 1.3), y - Trunc(tam / 6), x +
        Trunc(tam / 3), y + Trunc(tam / 3.5));
      // Flecha
      dib.Canvas.Line(x + Trunc(tam / 1.3), y - Trunc(tam / 6), x +
        Trunc(tam / 2.5), y - Trunc(tam / 6));
      dib.Canvas.Line(x + Trunc(tam / 1.3), y + Trunc(tam / 3.5), x +
        Trunc(tam / 1.3), y - Trunc(tam / 6));
    end;
    5:
    begin // Jupiter
      x := x - Trunc(tam / 4);
      y := y - Trunc(tam / 7);
      dib.Canvas.Pen.Color := RGBToColor(210, 60, 120);
      dib.Canvas.Arc(x + Trunc(tam / 11), y + Trunc(tam / 5), x +
        Trunc(tam / 1.4), y + Trunc(tam / 1.2), -110 * 16, 210 * 16);

      dib.Canvas.Line(x + Trunc(tam / 1.7), y + Trunc(tam / 1.23),
        x + Trunc(tam * 1.1), y + Trunc(tam / 1.23));//1.45
      dib.Canvas.Line(x + Trunc(tam / 1.1), y + Trunc(tam / 1.6), x +
        Trunc(tam / 1.1), y + Trunc(tam));
    end;
    6:
    begin // Saturno
      x := x + Trunc(tam / 4);
      y := y - Trunc(tam / 9);
      dib.Canvas.Pen.Color := RGBToColor(90, 180, 0);
      dib.Canvas.Arc(x - Trunc(tam / 2), y + Trunc(tam / 2.1), x +
        Trunc(tam / 1.9), y + Trunc(tam), -90 * 16, 190 * 16);
      dib.Canvas.Line(x - Trunc(tam / 4), y + Trunc(tam / 5.5), x +
        Trunc(tam / 5), y + Trunc(tam / 5.5));
      dib.Canvas.Line(x - Trunc(tam / 16), y + Trunc(tam / 64), x -
        Trunc(tam / 16), y + Trunc(tam / 1.8));
    end;
    7:
    begin // Urano
      x := x + Trunc(tam / 7);
      y := y - Trunc(tam / 7);
      dib.Canvas.Pen.Color := RGBToColor(127, 127, 0);

      dib.Canvas.Arc(x - Trunc(tam / 1.7), y + Trunc(tam / 12), x +
        Trunc(tam / 7), y + Trunc(tam / 1.5), -50 * 16, 100 * 16); // izq.
      dib.Canvas.Arc(x + Trunc(tam / 1.45), y + Trunc(tam / 12), x +
        Trunc(tam * 1.2), y + Trunc(tam / 1.5), 130 * 16, 105 * 16);// der.

      dib.Canvas.Line(x + Trunc(tam / 9), y + Trunc(tam / 2.5), x +
        Trunc(tam / 1.5), y + Trunc(tam / 2.5));
      dib.Canvas.Line(x + Trunc(tam / 2.5), y + Trunc(tam / 5), x +
        Trunc(tam / 2.5), y + Trunc(tam / 1.5));
      Circle(dib, x + (tam / 2.5), y + (tam / 1.1), tam / 4.5);
    end;
    8:
    begin // Neptuno
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x + Trunc(tam / 15), y + Trunc(tam / 206), x +
        Trunc(tam / 1.12), y + Trunc(tam / 1.7), -200 * 16, 220 * 16); //-180, 180
      dib.Canvas.Line(x + Trunc(tam / 3.7), y + Trunc(tam / 1.2), x +
        Trunc(tam / 1.4), y + Trunc(tam / 1.2));
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 5), x +
        Trunc(tam / 2), y + Trunc(tam));
    end;
    9:
    begin // Pluton
      dib.Canvas.Pen.Color := RGBToColor(60, 120, 210);
      dib.Canvas.Arc(x + Trunc(tam / 24), y + Trunc(tam / 128), x +
        Trunc(tam / 1.05), y + Trunc(tam / 1.7), -200 * 16, 220 * 16); // -180, 180
      Circle(dib, x + (tam / 2), y + (tam / 3.5), tam / 4.7);
      dib.Canvas.Line(x + Trunc(tam / 3.7), y + Trunc(tam / 1.2), x +
        Trunc(tam / 1.4), y + Trunc(tam / 1.2));
      dib.Canvas.Line(x + Trunc(tam / 2), y + Trunc(tam / 2), x +
        Trunc(tam / 2), y + Trunc(tam));
    end;
    10:
    begin // Nodo
      x := x + Trunc(tam / 9);
      dib.Canvas.Pen.Color := RGBToColor(120, 120, 200);
      dib.Canvas.Arc(x + Trunc(tam / 6), y + Trunc(tam / 9), x +
        Trunc(tam / 1.6), y + Trunc(tam * 1.2), -10 * 16, 200 * 16); // -1, 180
      Circle(dib, x + (tam / 18), y + (tam / 1.2), tam / 6);
      Circle(dib, x + (tam / 1.36), y + (tam / 1.2), tam / 6);
    end;
    11:
    begin // Ascendente
      x := x - Trunc(tam / 9);
      y := y - Trunc(tam / 9);
      dib.Canvas.TextOut(x, y, 'As');
    end;
    12:
    begin // Medio Cielo
      x := x - Trunc(tam / 6);
      y := y - Trunc(tam / 9);
      dib.Canvas.TextOut(x, y, 'Mc');
    end;
  end;
end;


function separaPlanetas(Rtr: integer; lpl: lp; longi: longPl): lp;
var
  yata, juntos: boolean;
  i, j: integer;
  sep, falta, ps: single;
begin

  yata := False;
  juntos := False;
  while (yata = False) do
  begin
    for i := 0 to 10 do
    begin
      for j := (i + 1) to 11 do
      begin
        sep := Abs(lpl[i] - lpl[j]);
        if (sep < 6) then
        begin
          falta := ((6 - sep) / 2) + 0.05;
          juntos := True;
          if (lpl[i] > lpl[j]) then
          begin
            lpl[i] := lpl[i] + falta;
            lpl[j] := lpl[j] - falta;
          end
          else
          begin
            lpl[i] := lpl[i] - falta;
            lpl[j] := lpl[j] + falta;
          end;
        end;
      end; // j
    end; // i
    if (juntos) then
    begin
      juntos := False;
    end
    else
    begin
      yata := True;
    end;
  end; // while
  for i := 0 to 10 do
  begin // Ajuste final
    for j := (i + 1) to 11 do
    begin
      if (longi[Rtr][i] > longi[Rtr][j]) and (lpl[i] < lpl[j]) or
        (longi[Rtr][i] < longi[Rtr][j]) and (lpl[i] > lpl[j]) then
      begin
        ps := lpl[i];
        lpl[i] := lpl[j];
        lpl[j] := ps;
      end;
    end; // j
  end; // i
  SeparaPlanetas := lpl;
end;

function minutozod(longip: single): string;
var
  s: string;
  n: integer;
begin
  n := round((longip - trunc(longip)) * 60);
  Str(n, s);
  if n < 10 then
    s := '0' + s;
  minutozod := s;
end;

procedure simboloAspecto(Tv:TImage;xp,yp,tam,distancia:integer;sc:single);
  var fig: integer;
begin
  if (distancia = 0) then begin
    fig := 97;
    // xp := xp + Trunc(sc * 2.5);
    // yp := yp + Trunc(sc * 2.3);
    Circle(Tv, xp + (tam / 7), yp + (tam / 2), tam / 3.7);
    Tv.Canvas.Line(xp + Trunc(tam / 1.5), yp - Trunc(tam / 9), xp +
      Trunc(tam / 3), yp + Trunc(tam / 3.5));
  end
  else if (distancia = 180) then begin
    fig := 101;
    // xp := xp + Trunc(sc * 2.3);
    // yp := yp + Trunc(sc * 2.3);
    Circle(Tv, xp + (tam / 7), yp + (tam / 2), tam / 4.5);
    Tv.Canvas.Line(xp + Trunc(tam / 2.1), yp + Trunc(tam / 3), xp +
      Trunc(tam / 12), yp + Trunc(tam / 3.5));
    Circle(Tv, xp + (tam / 1.5), yp + (tam / 7), tam / 4.5);
  end
  else if (distancia = 120) then begin
    fig := 98;
    // xp := xp + Trunc(sc * 2.3);
    // yp := yp + Trunc(sc * 2.3);
    Tv.Canvas.Line(xp + Trunc(tam / 1.05), yp + Trunc(tam / 1.3),
      xp - Trunc(tam / 12), yp + Trunc(tam / 1.3));
    Tv.Canvas.LineTo(xp + Trunc(tam / 2.5), yp - Trunc(tam / 12));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.05), yp + Trunc(tam / 1.3));
  end
  else if (distancia = 90) then begin
    fig := 100;
    // xp := xp + Trunc(sc * 2.3);
    // yp := yp + Trunc(sc * 2.3);
    Tv.Canvas.Rectangle(xp + Trunc(tam / 1.2), yp - Trunc(tam / 12),
      xp - Trunc(tam / 64), yp + Trunc(tam / 1.3));
  end
  else if (distancia = 60) then begin
    fig := 99;
    // xp := xp + Trunc(sc * 2.3);
    Tv.Canvas.Line(xp + Trunc(tam / 1.3), yp + Trunc(tam / 2.1), xp -
      Trunc(tam / 6.5), yp + Trunc(tam / 2.1)); // 9    / 2
    Tv.Canvas.Line(xp + Trunc(tam / 1.5), yp + Trunc(tam / 12), xp +
      Trunc(tam / 87), yp + Trunc(tam / 1.2));
    Tv.Canvas.Line(xp + Trunc(tam / 87), yp + Trunc(tam / 12), xp +
      Trunc(tam / 1.5), yp + Trunc(tam / 1.2));
  end
  else if (distancia = 45) then begin
    fig := 103;
    Tv.Canvas.Line(xp + Trunc(tam / 1.3), yp + Trunc(tam / 1.3),
      xp + Trunc(tam / 87), yp + Trunc(tam / 1.3)); // xd, xi
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.3), yp + Trunc(tam / 87));
  end
  else if (distancia = 135) then begin
    fig := 107;
    // xp := xp + Trunc(sc * 2.3);
    // yp := yp + Trunc(sc * 1.5);
    Tv.Canvas.Rectangle(xp + Trunc(tam / 1.2), yp - Trunc(tam / 12),
      xp - Trunc(tam / 64), yp + Trunc(tam / 1.3));
    Tv.Canvas.Line(xp + Trunc(tam / 2.6), yp + Trunc(tam / 1.7),
      xp + Trunc(tam / 2.6), yp + Trunc(tam / 1.05));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.5), yp + Trunc(tam / 1.05));
  end
  else if (distancia = 72) then begin
    Tv.Canvas.Line(xp + Trunc(tam / 2.6), yp - Trunc(tam / 12), xp +
      Trunc(tam / 2.6), yp + Trunc(tam / 2));  // Vertical
    Tv.Canvas.Line(xp + Trunc(tam / 1.2), yp + Trunc(tam / 4), xp -
      Trunc(tam / 6.5), yp + Trunc(tam / 4)); // Horizontal
    Tv.Canvas.Line(xp + Trunc(tam / 87), yp + Trunc(tam / 1.3), xp +
      Trunc(tam / 2.6), yp + Trunc(tam / 4));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.3), yp + Trunc(tam / 1.3));
  end
  else if (distancia = 144) then begin
    Tv.Canvas.Line(xp + Trunc(tam / 2.6), yp - Trunc(tam / 12), xp +
      Trunc(tam / 2.6), yp + Trunc(tam / 2));  // Vertical
    Tv.Canvas.Line(xp + Trunc(tam / 1.2), yp + Trunc(tam / 4), xp -
      Trunc(tam / 6.5), yp + Trunc(tam / 4)); // Horizontal
    Tv.Canvas.Line(xp + Trunc(tam / 87), yp + Trunc(tam / 1.3), xp +
      Trunc(tam / 2.6), yp + Trunc(tam / 4));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.3), yp + Trunc(tam / 1.3));
  end
  else if (distancia = 150) then begin
    fig := 104;
    // xp := xp + Trunc(sc * 2.3);
    Tv.Canvas.Line(xp + Trunc(tam / 1.2), yp + Trunc(tam / 4), xp -
      Trunc(tam / 6.5), yp + Trunc(tam / 4)); // Horizontal
    Tv.Canvas.Line(xp + Trunc(tam / 87), yp + Trunc(tam / 1.3), xp +
      Trunc(tam / 2.6), yp + Trunc(tam / 4));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.3), yp + Trunc(tam / 1.3));
  end
  else if (distancia = 30) then begin
    fig := 102;
    // xp := xp + Trunc(sc * 2.3);
    Tv.Canvas.Line(xp + Trunc(tam / 1.2), yp + Trunc(tam / 1.3),
      xp - Trunc(tam / 6.5), yp + Trunc(tam / 1.3));// Horizontal 1.3,6.5
    Tv.Canvas.Line(xp + Trunc(tam / 12), yp + Trunc(tam / 6), xp +
      Trunc(tam / 2.7), yp + Trunc(tam / 1.3));
    Tv.Canvas.LineTo(xp + Trunc(tam / 1.5), yp + Trunc(tam / 6));
  end
  else if (distancia = 999) then // Paralelo
  begin
    // fig := 101;
    Tv.Canvas.Line(xp + Trunc(tam / 4.3), yp + Trunc(tam), xp +
      Trunc(tam / 4.3), yp + Trunc(tam / 12.5));
    Tv.Canvas.Line(xp + Trunc(tam / 1.9), yp + Trunc(tam), xp +
      Trunc(tam / 1.9), yp + Trunc(tam / 12.5));
  end
  else if (distancia = 909) then // Antiparalelo
  begin
    // fig := 101;
    Tv.Canvas.Line(xp + Trunc(tam / 4.3), yp + Trunc(tam), xp +
      Trunc(tam / 4.3), yp + Trunc(tam / 12.5));
    Tv.Canvas.Line(xp + Trunc(tam / 1.9), yp + Trunc(tam), xp +
      Trunc(tam / 1.9), yp + Trunc(tam / 12.5));
    Tv.Canvas.Line(xp + Trunc(tam / 1.3), yp + Trunc(tam / 1.9), xp +
      Trunc(tam / 24), yp + Trunc(tam / 1.9)); //1.7, 24
  end;
end;

procedure cuadroAspectos(imprimir: boolean; sc: single; LongP: LongPl;
  Tv, sb: TImage; tam: integer; sinas:boolean);
var
  ancho, correc, x0, y0, px0, py0, x, y, wx, wy, px, py, xp, yp, ty,
  mw, fig, distancia: integer;
  d, s: string;
  lp, orbe: single;
  aspectan: aspectado;
begin
  x0 := trunc(12 * sc);
  y0 := trunc(350 * sc);
  wx := 0;
  wy := 0;
  ancho := trunc(20 * sc);
  mw := trunc(ancho / 4.5);
  ty := y0 + trunc(ancho * 14);

  if imprimir then
  begin
    Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
    lp := 1.01;
  end
  else
  begin
    lp := 1;
    Tv.Canvas.Font.Color := RGBToColor(255, 255, 255);
  end;

  for x := 0 to 14 do
  begin

    if x = 0 then
    begin // Quitar rayita vertical sobrante
      wy := wy + ancho;
    end;
    if x = 14 then
    begin // Quitar rayita horizontal sobrante
      wx := wx - ancho;
    end;

    if x < 12 then
    begin
      fig := x;
    end
    else if x = 12 then
    begin
      fig := 20; // Mc
    end;
    colorPincel(imprimir, Tv);
    Tv.Canvas.Pen.Width := Round(Sc * 1);
    Tv.Canvas.Line(x0, y0 + wy, x0 + wx, y0 + wy); // Horizontales
    Tv.Canvas.Line(x0 + wx, y0 + wy, x0 + wx, ty); // Verticales
    if x = 0 then
      wy := wy - ancho;

    if x < 11 then
    begin
      Dibuja_Planeta(imprimir, Tv, sb, x0 + wx + mw, y0 + wy + ancho, fig, tam);
    end
    else if x = 11 then
    begin
      Tv.Canvas.Font.Name := 'monospace';
      Tv.Canvas.Font.Size := Trunc(10.0 * sc);
      correc := Trunc(5.4 * sc);
      Tv.Canvas.TextOut(x0 + Trunc(lp * x * 20 * sc), y0 +
        Trunc(15.2 * 15.85 * sc), 'As');
    end
    else if x = 12 then
    begin
      Tv.Canvas.Font.Name := 'monospace';
      Tv.Canvas.Font.Size := Trunc(10.0 * sc);
      correc := Trunc(5.4 * sc);
      Tv.Canvas.TextOut(x0 + Trunc(lp * x * 20 * sc), y0 +
        Trunc(16.4 * 15.85 * sc), 'Mc');
    end;

    wy := wy + ancho;
    wx := wx + ancho;
  end;

  // *** ASPECTOS ***
  // *** Limpiar tabla ***
  for px := 0 to 29 do
  begin
    for py := 0 to 29 do
    begin
      aspectan[px, py] := -1;
    end;
  end;
  // *** Primera pasada ***
  for px := 0 to 11 do
  begin
    for py := px + 1 to 12 do
    begin
      y := py;
      if (py = 12) then
      begin
        y := 20;
      end;
      distancia := calcula_aspecto(longP, px, y, sinas, 0);
      aspectan[px, y] := distancia;
      aspectan[y, px] := distancia;
    end;
  end;
  // *** Segunda pasada (Sólo para metodo de la transmisión del aspecto) ***
  {
  for px := 0 to 11 do begin // natal 1
    for py:= px + 1 to 12 do begin // natal 2
      y:= py;
      if (py = 12) then begin
        y := 20;
      end;
      if (aspectan[px, y] > -1) then begin // Hay aspecto natal
        for xp:= 0 to (12) do begin // ¿to (py)-1? Miramos si el otro natal tiene aspectos con otro planeta
          x:= xp;
          if (xp = 12) then begin
            x := 20;
          end;
          distancia := calcula_aspecto(longP, y, x, false, 0);
          if (distancia > -1) then begin
            // El planeta aspectado, hace aspecto a otro que no aspecta con uno de ellos:
            if (aspectan[px, x]= -1) then begin
              if (x <> 10) and (y <> 10) then begin // De momento sin nodo lunar
                orbe:= abs(longP[0,px]-longP[0,y]);
                if orbe > 190 then orbe:= 360-orbe;
                distancia := calcula_aspecto(longP, px, y, false, 0);
                orbe := 6 - (abs(orbe-distancia)/2);
                aspectan[px, x]:= calcula_aspecto(longP, px, x, false, orbe);
                aspectan[x,px]:=aspectan[px, x];
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  }
  Tv.Canvas.Pen.Width := Trunc(tam / 7);
  Tv.Canvas.Font.Name := 'monospace'; //'Astrologia';
  Tv.Canvas.Font.Size := Trunc(7.0 * sc);
  correc := Trunc(5.4 * sc);
  for x := 0 to 11 do
  begin
    px := x;
    for y := x + 1 to 12 do
    begin
      if y < 12 then
      begin
        py := y;
      end
      else if y = 12 then
      begin
        py := 20;
      end;

      xp := x0 + correc + (x * ancho);
      yp := y0 + correc + ancho + (y * ancho);
      px0 := xp + tam;
      py0 := yp + tam;

      distancia := aspectan[px, py];
      // calcula_aspecto(longP,px, py, false, true); //aspectan[px,py];  //!!! calcula_aspecto(longP,px, py, false);
      if (distancia > -1) then
      begin
        ancho := ancho * 1;
        simboloAspecto(Tv,xp,yp,tam,distancia, sc);
        // Tv.Canvas.TextOut(x0 + correc + (x * ancho), y0 + correc + ancho + (y * ancho), chr(fig));
        {str(distancia, s);
        d:= 'asp' + s + '.png';
        sb.Picture.LoadFromFile(d);
        xp:= x0 + correc + (x * ancho);
        yp:= y0 + correc + ancho + (y * ancho);
        px0:= xp + tam;
        py0:= yp + tam;
        Tv.Picture.Bitmap.Canvas.StretchDraw(Rect(xp, yp, px0, py0),sb.Picture.Bitmap);}
      end;
    end;
  end;
end;

procedure cuadroExplica(sc: single; Tv, sb: TImage);
const
  imprimir = True;
var
  ancho, correc, x0, y0, x, y, wx, wy, mw, tm, ty, px, py, xp, yp: integer;
  nss, nps, nas: string;
  ns, np, na: array of string;
  vert, tam: single;
begin
  nps := 'Sol,Luna,Mercurio,Venus,Marte,Júpiter,Saturno,Urano,Neptuno,Plutón,Nodo Lunar,Ascendente,Medio Cielo';
  np := vbSplit(nps, ',');
  nss := 'Aries,Tauro,Géminis,Cáncer,Leo,Virgo,Libra,Escorpio,Sagitario,Capricornio,Acuario,Piscis';
  ns := vbSplit(nss, ',');
  nas := 'Conjunción,Oposición,Trígono,Cuadratura,Sextil,Semisextil,Quincuncio';
  na := vbSplit(nas, ',');

  x0 := Round(20 * sc);
  y0 := Round(355 * sc);  // 350
  wx := 0;
  wy := 0;
  mw := Round(ancho / 4.5);
  ty := y0 + Round(ancho * 14);
  // ***** Cuadros *****
  // Signos
  Tv.canvas.Rectangle(x0 - Round(sc * 8), y0 + Round(283 * sc), x0 +
    Round(228 * sc), y0 + Round(430 * sc));
  Tv.canvas.Line(x0 - Round(sc * 8), y0 + Round(305 * sc), x0 +
    Round(228 * sc), y0 + Round(305 * sc));
  // Planetas
  Tv.canvas.Rectangle(x0 + Round(sc * 235), y0 + Round(283 * sc), x0 +
    Round(471 * sc), y0 + Round(430 * sc));
  Tv.canvas.Line(x0 + Round(sc * 235), y0 + Round(305 * sc), x0 +
    Round(471 * sc), y0 + Round(305 * sc));
  // Aspectos
  Tv.canvas.Rectangle(x0 + Round(sc * 477), y0 + Round(283 * sc), x0 +
    Round(590 * sc), y0 + Round(430 * sc));
  Tv.canvas.Line(x0 + Round(sc * 477), y0 + Round(305 * sc), x0 +
    Round(590 * sc), y0 + Round(305 * sc));


  Tv.Canvas.Font.Name := 'Monospace';
  {Tv.Canvas.Font.Size:= Round(7.0 * sc);
  Tv.canvas.TextOut(x0 + Round(255 * sc), y0 + Round(sc * 222), 'Longitud');
  Tv.canvas.TextOut(x0 + Round(255 * sc), y0 + Round(sc * 234), 'Eclíptica');
  Tv.canvas.TextOut(x0 + Round(255 * sc), y0 + Round(sc * 246), 'Geocént.');
  Tv.canvas.TextOut(x0 + Round(255 * sc), y0 + Round(sc * 258), 'Tropical');}

  Tv.Canvas.Font.Size := Round(9.0 * sc);
  Tv.canvas.TextOut(x0, y0 + Round(sc * 288), 'Los signos del zodíaco');
  px := x0 + Round(sc * 31);
  for x := 0 to 11 do
  begin
    if x > 5 then
    begin
      px := x0 + Round(sc * 140);
      py := y0 + Round(sc * 311) + Round(sc * (x - 6) * 19);
    end
    else
    begin
      py := y0 + Round(sc * 311) + Round((sc * x) * 19);
    end;
    Tv.canvas.TextOut(px, py, ns[x]);
  end;

  Tv.canvas.TextOut(x0 + Round(sc * 245), y0 + Round(sc * 288), 'Los planetas');
  px := x0 + Round(sc * 272);
  for x := 0 to 10 do
  begin
    if x > 5 then
    begin
      px := x0 + Round(sc * 392);
      py := y0 + Round(sc * 311) + Round(sc * (x - 6) * 19);
    end
    else
    begin
      py := y0 + Round(sc * 311) + Round((sc * x) * 19);
    end;
    Tv.canvas.TextOut(px, py, np[x]);
  end;

  Tv.canvas.TextOut(x0 + Round(sc * 485), y0 + Round(sc * 288), 'Los aspectos');
  px := x0 + Round(sc * 510);
  tam := sc * 12;
  vert := 2.3;
  for x := 0 to 6 do
  begin
    py := y0 + Round(sc * 311) + Round((sc * x) * 16);// * 19
    Tv.canvas.TextOut(px, py, na[x]);
    xp := px;
    yp := py;
    if x = 0 then
    begin // Conjuncion
      xp := xp - Trunc(tam * 2);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),0,sc);
    end
    else if x = 1 then
    begin // Oposicion
      xp := xp - Trunc(tam * 2);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),180,sc);
    end
    else if x = 2 then
    begin // Trigono
      xp := xp - Trunc(tam * 2);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),120,sc);
    end
    else if x = 3 then
    begin // Cuadratura
      xp := xp - Trunc(tam * 2);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),90,sc);
    end
    else if x = 4 then
    begin  // Sextil
      xp := xp - Trunc(tam * 1.9);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),60,sc);
    end
    else if x = 5 then
    begin  // Semisextil
      xp := xp - Trunc(tam * 1.9);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),30,sc);
    end
    else if x = 6 then
    begin  // Quincuncio
      xp := xp - Trunc(tam * 1.9);
      yp := yp + Trunc(sc * vert);
      simboloAspecto(Tv,xp,yp,Trunc(tam),150,sc);
    end;
  end;

  Tv.Canvas.Font.Name := 'monospace'; //'AstroGadget';
  tm := Round(12.0 * sc); // 16.0 no vectorial
  Tv.Canvas.Font.Size := tm;
  px := x0 + Round(sc * 3); // Dibuja signos

  for x := 0 to 11 do
  begin
    if x > 5 then
    begin
      px := x0 + Round(sc * 110);
      py := y0 + Round(310 * sc) + Round(sc * (x - 6) * 19);
    end
    else
    begin
      py := y0 + Round(310 * sc) + Round((sc * x) * 19);
    end;
    Dibuja_Signo(False, Tv, sb, px, py, x + 1, tm);
  end;

  px := x0 + Round(sc * 247); // Dibuja planetas
  for x := 0 to 10 do
  begin
    if x > 5 then
    begin
      px := x0 + Round(sc * 367);
      py := y0 + Round(307 * sc) + Round(sc * (x - 6) * 19);
    end
    else
    begin
      py := y0 + Round(307 * sc) + Round((sc * x) * 19);
    end;
      Dibuja_Planeta(imprimir, Tv, sb, px, py, x, tm);
  end;

  { // ???
  Tv.Canvas.Font.Name:='Astrologia';
  Tv.Canvas.Font.Size:= Round(9.0 * sc);
  Tv.Canvas.Font.Bold:= True;

  px:= x0 + Round(sc * 485); // Dibuja aspectos   482
  // (104-> Qnx,102-> Semisextil)
  py:= y0 + Round(sc * 312);
  Tv.Canvas.TextOut(px, py, chr(97)); // Conj.
  py:= py + Round(sc * 19);
  Tv.Canvas.TextOut(px, py, chr(101)); // Opo.
  py:= py + Round(sc * 19);
  Tv.Canvas.TextOut(px, py, chr(98)); // Trig.
  py:= py + Round(sc * 19);
  Tv.Canvas.TextOut(px, py, chr(100)); // Cuad.
  py:= py + Round(sc * 19);
  Tv.Canvas.TextOut(px, py, chr(99)); // Sext.
  }
  Tv.Canvas.Font.Bold := False;
end;

procedure dibujaCarta(Rtr, ancho, alto: integer; longip: LongPl;
  vel: Vl; Tv: TImage; datos: string; imprimir: boolean; sb: TImage);
// const
// colSky : TFPColor = (Red: $0000; Green: $8800; Blue: $aa00; Alpha: alphaOpaque);
var
  {
  Img: TFPMemoryImage;
  Writer: TFPWriterPNG;
  ms: TMemoryStream;
  ImgCanvas: TFPImageCanvas;
  AFont: TFreeTypeFont;
  fs: TFileStream;
  }
  // AFont : TFreeTypeFont;
  cnt: longint;
  i, j, distancia, signo, tm, dsd: integer;
  cientochenta, sc, sc2, Radi, Radi2, Radi3, Radi4, correc, ini0: single;
  c, cx, cy, x, y, x2, y2, x3, y3: longint;
  lpl: lp;
  Forecolor: TColor;
  s, cad: string;
  Dt: array of string;
  writer: TFPWriterJPEG;
  sinas: boolean;
begin
  // _______________________________________________________________________
   {
   // *** Para memoria ***
   Img:=nil;
   ImgCanvas:=nil;
   Writer:=nil;
   ms:=nil;
   fs:=nil;
   AFont:=nil;
  // try
    // *** Para memoria ***
    // initialize free type font manager
    ftfont.InitEngine;
    FontMgr.SearchPath:='/usr/share/fonts/truetype/freefont/'; // ??? Window$
    AFont:=TFreeTypeFont.Create;
    // create an image of width 200, height 100
    Img:=TFPMemoryImage.Create(ancho, alto);
    Img.UsePalette:= false;
    create the canvas with the drawing operations
    ImgCanvas:=TFPImageCanvas.create(Img);

    // paint text
    ImgCanvas.Font:=AFont;
    ImgCanvas.Font.Name:= 'Astrologia';//'AstroGadget'; // 'FreeMono';
    ImgCanvas.Font.Size:= Round(32.0 * sc);
    // ImgCanvas.TextOut(10,30,'1234567890');

    // *** Marco ***
    Tv.Canvas.Pen.Color:=RGBToColor(0,136,170);
    Tv.Canvas.Pen.Width:= 3;
    Tv.Canvas.Rectangle(-10, -10, Tv.Width, Tv.Width);
    // *********}
  if (Rtr = 1) then begin // Sinastria
    sinas := True;
  end
  else begin
    sinas := False;
  end;

  if imprimir then
  begin
    Tv.Canvas.Pen.Color := RGBToColor(255, 255, 255);
  end
  else
  begin
    Tv.Canvas.Pen.Color := RGBToColor(60,90,120);
  end;

  // ********* 19 Nov 2014 *********
  if imprimir then begin
    // Escala del grafico:
    sc := (Tv.Height+Tv.Width)/1475;
  end
  else begin
    if (Tv.Height=1550) and (Tv.Width=1344) then begin
      sc := ancho/680; // graficoBMP
    end
    else begin
      sc := (Tv.Height+Tv.Width)/3800;//820; // escala
    end;
  end;
  alto:= Trunc(sc*784);
  //********************************
  Tv.Canvas.Clear;
  if imprimir then begin
    Tv.Canvas.Brush.Color:=RGBToColor(255, 255, 255);
  end
  else begin
    Tv.Canvas.Brush.Color:=RGBToColor(60,90,120); //Color de fondo
  end;
  Tv.Canvas.FillRect(0,0,Tv.Width,Tv.Height);
  Tv.Canvas.Pen.Width := 1;
  SetBkMode(Tv.Canvas.Handle, TRANSPARENT); // Fuentes ... transparentes

    {if imprimir then begin // Cargar imagen en blanco
      Tv.Picture.Bitmap.LoadFromFile('blancosupergrafico.bmp');
    end
    else begin
      Tv.Picture.Bitmap.LoadFromFile('blancografico.bmp');
    end;}

    {if imprimir then begin // Guardar imagen en blanco
      Tv.Picture.SaveToFile('blancosupergrafico.bmp');
    end
    else begin
      Tv.Picture.SaveToFile('blancografico.bmp');
    end;}

  sc2 := sc;
  Tv.Canvas.Font.Name := 'Monospace';
  Tv.Canvas.Font.Size := Round(sc * 9);

  if imprimir then
  begin
    Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
  end
  else
  begin
    Tv.Canvas.Font.Color := RGBToColor(255, 255, 255); //(207, 207, 207);
  end;

  Dt := vbSplit(datos, ',');
  Tv.Canvas.TextOut(Round(5 * sc), Round(5 * sc), Dt[0]);
  cad := Dt[1] + '-' + Dt[2] + '-' + Dt[3];
  Tv.Canvas.TextOut(Round(5 * sc), Round(20 * sc), cad);
  cad := Dt[4] + ':' + Dt[5] + ' ' + Dt[6] + ':' + Dt[7] + ' ' + Dt[8];
  Tv.Canvas.TextOut(Round(5 * sc), Round(35 * sc), cad);
  Cad := Dt[9] + ' ' + Dt[10];
  Tv.Canvas.TextOut(Round(5 * sc), Round(50 * sc), cad);
  Cad := Dt[11] + Dt[12] + Dt[13] + ' ' + Dt[14] + Dt[15] + Dt[16];
  Tv.Canvas.TextOut(Round(5 * sc), Round(65 * sc), cad);

  Tv.Canvas.TextOut(Round(495 * sc), Round(5 * sc), 'Juan M. Puertas');
  Tv.Canvas.TextOut(Round(495 * sc), Round(20 * sc), 'Tel. 958 124138');
  Tv.Canvas.TextOut(Round(495 * sc), Round(35 * sc), 'astro.regulus@gmail');

  Tv.Canvas.TextOut(Round(5 * sc), Round(112 * sc), 'Topocéntricas');


  Tv.Canvas.Font.Name := 'monospace'; //'AstroGadget';
  tm := Round(21.0 * sc);
  Tv.Canvas.Font.Size := tm;
  Ini0 := Round(en360(630 - (longip[Rtr, 11]))); // 0, 11

  // *** Carta y grados ***
    {
    if imprimir then begin
      cx:= Round((sc * (alto / 3 )) /  (sc * 2.24)); // 2.3
      cy:= Round((sc * (alto / 3)) /  (sc * 2.71)); // 2.5
    end
    else begin
      cx:= Round((sc * alto) / (sc * 2.24)); // 2.23
      cy:= Round((sc * alto) / (sc * 2.71)); // 2.70
    end;
    }

  cx := Round((sc * alto) / (sc * 2.25)); // 2.24
  cy := Round((sc * alto) / (sc * 2.71)); // 2.70


  // DibujaGrado(ImgCanvas, IniRad, sc, cx, cy);
  //(207,207,225); // blanco azulado

  colorPincel(imprimir, Tv);

  if Rtr = 1 then
    sc := sc2 * 0.81;
  DibujaGrado(Tv, Round(Ini0), sc, cx, cy, Rtr);
  {
  // <<<
  AFont:= TFreeTypeFont.Create;
  AFont.Name:= 'Astrologia.ttf';
  Tv.Canvas.Font:=AFont;
  //Tv.Canvas.Font.Name:='Astrologia';
  Tv.Canvas.Font.Size:=9;
  Tv.Canvas.TextOut(10,90,'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ');
  }
  for i := 0 to 11 do
  begin
    lpl[i] := longip[0, i];
  end;

  lpl := separaPlanetas(0, lpl, longip);
  correc := (21.0 * sc) / 2; // Por el tamaño de la fuente

  // *** Raya de posicion, planetas y 'R' ***
  Radi := sc * 265 * 0.8;   // radio interno raya
  Radi2 := sc * 272 * 0.8;  // radio externo raya
  Radi3 := sc * 237 * 0.8;  // radio planetas  245

  for i := 0 to 10 do
  begin
    lpl[i] := (longip[0, i] + longip[0, i] + lpl[i]) / 3;
    x := cx + Round(Radi * Sin(Degtorad(ini0 + lpl[i]))); // radianes
    x2 := cx + Round(Radi2 * Sin(Degtorad(ini0 + longip[0, i])));
    y := cy + Round(Radi * Cos(Degtorad(ini0 + lpl[i])));
    y2 := cy + Round(Radi2 * Cos(Degtorad(ini0 + longip[0, i])));
    // ImgCanvas.Line(x, y, x2, y2);

    colorPincel(imprimir, Tv);
    Tv.Canvas.Pen.Width := Round(Sc * 1);

    Tv.Canvas.Line(x, y, x2, y2);
    x := cx + Round(Radi3 * Sin(Degtorad(ini0 + lpl[i])));
    x := x - Round(correc);
    y := cy + Round(Radi3 * Cos(Degtorad(ini0 + lpl[i])));
    y := y - Round(correc * 1.7);
    Dibuja_Planeta(imprimir, Tv, sb, x, y, i, tm);
  end;
  Tv.Canvas.Pen.Width := 1;

  // *** Retrogrados ***
  if imprimir then
  begin
    Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
  end
  else
  begin
    Tv.Canvas.Font.Color := RGBToColor(255, 255, 255); //(207, 207, 207);
  end;
  Tv.Canvas.Font.Size := Round(9 * sc);
  correc := (9 * sc) / 2;
  Radi := sc * 258 * 0.8; // radio
  for i := 1 to 10 do
  begin
    if (Vel[0, i] < 0) then
    begin
      x := cx + Round(Radi * Sin(Degtorad(ini0 + lpl[i])));
      // x := x - Round(correc);
      y := cy + Round(Radi * Cos(Degtorad(ini0 + lpl[i])));
      // if Rtr = 0 then y := y - Round(correc * 2) else y := y - Round(correc);
      y := y - Round(correc * 1.5);
      Tv.Canvas.TextOut(x, y, 'R');
    end;
  end;

  if Rtr = 1 then
  begin  // *** PLANETAS RUEDA DOBLE ***
    Tv.Canvas.Font.Size := Round(21.0 * sc); // 18.0
    for i := 0 to 11 do
    begin
      lpl[i] := longip[Rtr, i];
    end;
    lpl := separaPlanetas(Rtr, lpl, longip);
    correc := (21.0 * sc) / 2; // Por el tamaño de la fuente
    Radi := sc * 360 * 0.8;   // radio ext. raya
    Radi2 := sc * 352 * 0.8;  // radio int. raya
    Radi3 := sc * 380 * 0.8;  // radio planetas
    for i := 0 to 10 do
    begin
      lpl[i] := (longip[Rtr, i] + longip[Rtr, i] + lpl[i]) / 3;
      x := cx + Round(Radi * Sin(Degtorad(ini0 + lpl[i])));
      x2 := cx + Round(Radi2 * Sin(Degtorad(ini0 + longip[Rtr, i])));
      y := cy + Round(Radi * Cos(Degtorad(ini0 + lpl[i])));
      y2 := cy + Round(Radi2 * Cos(Degtorad(ini0 + longip[Rtr, i])));
      // ImgCanvas.Line(x, y, x2, y2);

      colorPincel(imprimir, Tv);
      Tv.Canvas.Pen.Width := Round(Sc * 1);

      Tv.Canvas.Line(x, y, x2, y2);
      x := cx + Round(Radi3 * Sin(Degtorad(ini0 + lpl[i])));
      x := x - Round(correc * 1.5);
      y := cy + Round(Radi3 * Cos(Degtorad(ini0 + lpl[i])));
      y := y - Round(correc * 1.9);
      Dibuja_Planeta(imprimir, Tv, sb, x, y, i, tm);
    end;
  end;

  // *** Retrogrados Rueda Doble ***
  if Rtr = 1 then
  begin
    if imprimir then
    begin
      Tv.Canvas.Pen.Color := RGBToColor(0, 0, 0);
    end
    else
    begin
      Tv.Canvas.Pen.Color := RGBToColor(255, 255, 255); //(207, 207, 207);
    end;
    Tv.Canvas.Font.Size := Round(9 * sc);
    correc := (9 * sc) / 2;
    Radi := sc * 365 * 0.8; // radio  373
    for i := 1 to 10 do
    begin
      if (Vel[Rtr, i] < 0) then
      begin
        x := cx + Round(Radi * Sin(Degtorad(ini0 + lpl[i])));
        x := x - Round(correc);
        y := cy + Round(Radi * Cos(Degtorad(ini0 + lpl[i])));
        y := y - Round(correc * 1.6); // 1.7
        Tv.Canvas.TextOut(x, y, 'R');
      end;
    end;
  end;

  // *** SIGNOS ***
  tm := Round(21.0 * sc);
  Tv.Canvas.Font.Size := tm;
  correc := (21.0 * sc) / 2; // Por el tamaño de la fuente
  Radi := sc * 340 * 0.745; // 0.75;
  cnt := 0;
  j := 15;
  for i := 15 to 391 do
  begin
    cnt := cnt + 1;
    x := cx + Round(Radi * Sin(Degtorad(ini0 + j)));
    // No vectorial:
    // x := x - Round(correc); // / 1.2);  !!! Para font
    x := x - Round(correc / 2);
    y := cy + Round(Radi * Cos(Degtorad(ini0 + j)));
    y := y - Round(correc * 1.2);
    // Dibuja_Signo(False, ImgCanvas, x, y, cnt); // !!! Da error 'demasiados colores
    Dibuja_Signo(False, Tv, sb, x, y, cnt, tm);
    j := j + 30;
    if j > 360 then
      break;
  end;
  colorPincel(imprimir, Tv);
  // *** CASAS ***
  // ini0 := ini0 - 1;
  Radi3 := sc * 272 * 0.8; // radio externo
  Radi2 := sc * 200 * 0.8; // radio interno  215
  Radi4 := sc * 342 * 0.8; // radio externo ejes
  Radi := Radi3;
  for i := 1 to 12 do
  begin
    if (i = 1) or (i = 4) or (i = 7) or (i = 10) then
    begin
      Tv.Canvas.Pen.Width := Round(sc * 2);
      Radi := Radi4;
    end
    else
    begin
      Tv.Canvas.Pen.Width := Round(sc * 1);
      Radi := Radi3;
    end;
    x := cx + Round(Radi * Sin(Degtorad(ini0 + longip[0, i + 10])));
    x2 := cx + Round(Radi2 * Sin(Degtorad(ini0 + longip[0, i + 10])));
    y := cy + Round(Radi * Cos(Degtorad(ini0 + longip[0, i + 10])));
    y2 := cy + Round(Radi2 * Cos(Degtorad(ini0 + longip[0, i + 10])));
    Tv.Canvas.line(x, y, x2, y2);
  end;

  // *** Flechas de Rueda Doble ***

  Tv.Canvas.Pen.Width := Round(Sc * 4);
  Radi := Radi4 / 45;
  for i := 0 to 1 do
  begin
    if i = 0 then
      j := 11
    else
      j := 20;
    x := cx + Round(Radi4 * Sin(Degtorad(ini0 + longip[0, j])));
    y := cy + Round(Radi4 * Cos(Degtorad(ini0 + longip[0, j])));
    cientochenta := ((ini0 + longip[0, j])) + 180 + 25;
    if (cientochenta > 360) then
      cientochenta := cientochenta - 360;
    cientochenta := Degtorad(cientochenta);
    x2 := Round(Sin(cientochenta) * Radi);
    y2 := Round(Cos(cientochenta) * Radi);
    Tv.Canvas.line(x + x2, y + y2, x, y);
    x3 := x2;
    y3 := y2;
    cientochenta := (ini0 + (longip[0, j])) + 180 - 25;
    if (cientochenta > 360) then
      cientochenta := cientochenta - 360;
    cientochenta := Degtorad(cientochenta);
    x2 := Round(Sin(cientochenta) * Radi);
    y2 := Round(Cos(cientochenta) * Radi);
    Tv.Canvas.line(x + x2, y + y2, x, y);
  end;
  Tv.Canvas.Pen.Width := Round(sc * 2);

  if Rtr = 1 then
  begin // Rueda Doble. Casas
    // sch := 680 * sc;
    // r1 := sch / (1.98 * 1.25);
    Radi3 := sc * 412 * 0.8; // radio externo
    Radi2 := sc * 353 * 0.8; // radio interno  215
    Radi4 := sc * 412 * 0.8; // radio externo ejes
    Radi := Radi3;
    for i := 1 to 12 do
    begin
      if (i = 1) or (i = 4) or (i = 7) or (i = 10) then
      begin
        Tv.Canvas.Pen.Width := Round(sc * 2);
        //              Radi := Radi4;
      end
      else
      begin
        Tv.Canvas.Pen.Width := Round(sc * 1);
        Radi := Radi3;
      end;
      x := cx + Round(Radi * Sin(Degtorad(ini0 + longip[Rtr, i + 10])));
      x2 := cx + Round(Radi2 * Sin(Degtorad(ini0 + longip[Rtr, i + 10])));
      y := cy + Round(Radi * Cos(Degtorad(ini0 + longip[Rtr, i + 10])));
      y2 := cy + Round(Radi2 * Cos(Degtorad(ini0 + longip[Rtr, i + 10])));
      Tv.Canvas.line(x, y, x2, y2);
    end;
  end;

  // *** Flechas ***
  Tv.Canvas.Pen.Width := Round(Sc * 4);
  Radi := Radi4 / 45;
  for i := 0 to 1 do
  begin
    if i = 0 then
      j := 11
    else
      j := 20;
    x := cx + Round(Radi4 * Sin(Degtorad(ini0 + longip[Rtr, j])));
    y := cy + Round(Radi4 * Cos(Degtorad(ini0 + longip[Rtr, j])));
    cientochenta := ((ini0 + longip[Rtr, j])) + 180 + 25;
    if (cientochenta > 360) then
      cientochenta := cientochenta - 360;
    cientochenta := Degtorad(cientochenta);
    x2 := Round(Sin(cientochenta) * Radi);
    y2 := Round(Cos(cientochenta) * Radi);
    Tv.Canvas.line(x + x2, y + y2, x, y);
    x3 := x2;
    y3 := y2;
    cientochenta := (ini0 + (longip[Rtr, j])) + 180 - 25;
    if (cientochenta > 360) then
      cientochenta := cientochenta - 360;
    cientochenta := Degtorad(cientochenta);
    x2 := Round(Sin(cientochenta) * Radi);
    y2 := Round(Cos(cientochenta) * Radi);
    Tv.Canvas.line(x + x2, y + y2, x, y);
  end;
  Tv.Canvas.Pen.Width := Round(sc * 2);

  // *** Numeros de las Casas ***
  Tv.Canvas.Font.Size := Round(9.0 * sc);
  if imprimir then
  begin
    Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
  end
  else
  begin
    Tv.Canvas.Font.Color := RGBToColor(255, 255, 255); //(207,207,207);
  end;
  ini0 := en360(630 - longip[Rtr, 11]);
  // ini0:= en360(630 - longip[0,11]);
  // ini0:= ini0 + 1;
  // cad:='X,P, 2, 3, 4, 5, 6, 7, 8, 9,Q,11,12';
  cad := 'X, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12';
  dt := vbSplit(cad, ',');
  if Rtr = 0 then
  begin
    Radi := Radi2 * 1.05; // 1.04
  end
  else
  begin
    Radi := Radi2 * 0.6; // 1.04
  end;
  correc := (16.0 * sc) / 2;
    {for i:= 0 to 11 do begin
        x := cx + Round(Radi * Sin(Degtorad(ini0 + longip[Rtr,i + 11])));
        x := Round(x - correc);
        y := cy + Round(Radi * Cos(Degtorad(ini0 + longip[Rtr,i + 11])));
        y := Round(y - correc);
        Tv.Canvas.TextOut(x, y, dt[i]);
    end;}
  for i := 1 to 12 do
  begin
    if (i = 12) then
    begin
      cientochenta := longip[0, 11] - longip[0, 22]; // casa 12
    end
    else
    begin
      cientochenta := longip[0, i + 11] - longip[0, i + 10];// resto de las casas
    end;
    if cientochenta < 0 then
      cientochenta := 360 + cientochenta;
    cientochenta := cientochenta / 2.0;
    cientochenta := en360(longip[0, i + 10] + cientochenta);
    x := cx + Round(Radi * Sin(Degtorad(ini0 + cientochenta)));
    x := Round(x - correc);
    y := cy + Round(Radi * Cos(Degtorad(ini0 + cientochenta)));
    y := Round(y - (correc / 1.3));
    Tv.Canvas.TextOut(x, y, dt[i]);
  end;

  // *** Numeros de las Casas de la Rueda Doble ***
  if Rtr = 1 then
  begin
    Tv.Canvas.Font.Size := Round(9.0 * sc);
    if imprimir then
    begin
      Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
    end
    else
    begin
      Tv.Canvas.Font.Color := RGBToColor(255, 255, 255); //(207, 207, 207);
    end;
    Radi := Radi2 * 1.13;
    correc := (16.0 * sc) / 2;
      {for i:= 0 to 11 do begin
          x := cx + Round(Radi * Sin(Degtorad(ini0 + longip[Rtr,i + 11])));
          x := Round(x - correc);
          y := cy + Round(Radi * Cos(Degtorad(ini0 + longip[Rtr,i + 11])));
          y := Round(y - correc);
          Tv.Canvas.TextOut(x, y, dt[i]);
      end;}
    for i := 1 to 12 do
    begin
      if (i = 12) then
      begin
        cientochenta := longip[Rtr, 11] - longip[Rtr, 22]; // casa 12
      end
      else
      begin
        cientochenta := longip[Rtr, i + 11] - longip[Rtr, i + 10];// resto de las casas
      end;
      if cientochenta < 0 then
        cientochenta := 360 + cientochenta;
      cientochenta := cientochenta / 2.0;
      cientochenta := en360(longip[Rtr, i + 10] + cientochenta);
      x := cx + Round(Radi * Sin(Degtorad(ini0 + cientochenta)));
      x := Round(x - correc);
      y := cy + Round(Radi * Cos(Degtorad(ini0 + cientochenta)));
      y := Round(y - (correc / 1.3));
      Tv.Canvas.TextOut(x, y, dt[i]);
    end;
  end;

  //  """  Linea de aspectos """
  Tv.Canvas.Pen.Width := Round(Sc * 1.5);
  Radi := sc * 158; // radio de los aspectos
  for i := 0 to 9 do
  begin
    // for j := (i + 1) to 20 do //<<<
    if (sinas = false) then dsd := i + 1 else dsd := 0; //<<<
    for j := dsd to 20 do //<<<
    begin
      //<<< distancia := calcula_aspecto(longip, i, j, False, 0); //sinas=True???
      distancia := calcula_aspecto(longip, i, j, sinas, 0); //sinas=True???
      if (distancia > -1) then
      begin
        if (j <> 10) and (j < 12) or (j = 20) then
        begin
          if sinas then Rtr:=0;
          x := cx + Round(Radi * Sin(Degtorad(ini0 + longip[Rtr][i])));
          if sinas then Rtr:=1;
          x2 := cx + Round(Radi * Sin(Degtorad(ini0 + longip[Rtr][j])));
          if sinas then Rtr:=0;
          y := cy + Round(Radi * Cos(Degtorad(ini0 + longip[Rtr][i])));
          if sinas then Rtr:=1;
          y2 := cy + Round(Radi * Cos(Degtorad(ini0 + longip[Rtr][j])));
          // if sinas then Rtr:=1;
          if (distancia = 180) or (distancia = 90) then begin
            ForeColor := RGBToColor(180, 0, 0);//(128,0,0); // Rojo
          end
          else if (distancia = 120) or (distancia = 60) then begin
            ForeColor := RGBToColor(0, 0, 180);//(0,0,128); // Azul
          end
          else if (distancia = 45) or (distancia = 135) then begin
            ForeColor := RGBToColor(200, 90, 0);//(128,128,0); // Naranja
          end
          else if (distancia = 150) or (distancia = 30) then begin
            ForeColor := RGBToColor(0, 128, 0); // Verde
          end
          else if (distancia = 72) or (distancia = 144) then begin
            ForeColor := RGBToColor(128, 128, 0); // Amarillo
          end;

          // if (distancia <> 45) and (distancia <> 135) then begin // Sin 45 ni 135
            Tv.Canvas.Pen.Color := ForeColor;
            Tv.Canvas.line(x, y, x2, y2);
          // end;
        end;
      end;
    end;
  end;


  if Rtr = 1 then
    sc := sc2;
  // ***** Cuadro de posiciones planetarias *****
  colorPincel(imprimir, Tv);
  Tv.Canvas.Pen.Width := Round(Sc * 1);

  x := Round(300 * sc);
  y := Round(31.8 * 18 * sc);
  Tv.canvas.Rectangle(x - Round(24 * sc), y - Round(4 * sc), x +
    Round(310 * sc), y + Round(55 * sc));

  for i := 0 to 10 do
  begin // Planetas
    tm := Round(12.0 * sc);
    Tv.Canvas.Font.Size := tm;
    // Lo siguiente para grafico no vectorial:
    // Dibuja_Planeta(imprimir, Tv, sb, x - Round(12.5 * sc), y - Round(1.25 * sc), i, tm); // y - Round(3
    Dibuja_Planeta(imprimir, Tv, sb, x - Round(18 * sc), y -
      Round(1.25 * sc), i, tm);
    // y - Round(3
    signo := (Trunc(longip[Rtr, i]) div 30);
    s := minutozod(longip[Rtr, i]);
    j := Trunc(longip[Rtr, i]) - Trunc(signo * 30); // grados
    if s = '60' then
    begin
      s := '00';
      j := j + 1;
      if j = 30 then
      begin
        j := 0;
        signo := signo + 1;
        if (signo = 12) then
          signo := 0;
      end;
    end;
    tm := Round(9.0 * sc);
    Tv.Canvas.Font.Size := tm;
    Dibuja_Signo(False, Tv, sb, x + Round(21 * sc), y + Round(1.75 * sc),
      signo + 1, tm); // y
    Str(j, cad);
    if j < 10 then
      cad := '0' + cad;
    // cad := concat(cad, '    ', s);
    colorPincel(imprimir, Tv);
    Tv.Canvas.TextOut(x, y, cad);
    cad := s; // Minutos de arco
    if (Vel[Rtr, i] < 0) then begin
      cad := cad + 'R';
    end;
    Tv.Canvas.TextOut(x + Round(35 * sc), y, cad);

    if (i > 1) and (i < 5) then
    begin // Dividir columnas
      x := Round(380 * sc);
      y := Round(((i - 2) + 31.8) * 18 * sc);
    end
    else if (i > 4) and (i < 8) then
    begin
      x := Round(460 * sc);
      y := Round(((i - 5) + 31.8) * 18 * sc);
    end
    else if (i > 7) then
    begin
      x := Round(540 * sc);
      y := Round(((i - 8) + 31.8) * 18 * sc);
    end
    else if (i < 2) then
    begin
      x := Round(300 * sc);
      y := Round(((i + 1) + 31.8) * 18 * sc);
    end;
    // y:= Round(((i+1) + 4.5) * 18 * sc); // Quita si divides en columnas
  end;

  Tv.Canvas.Font.Name := 'monospace';
  Tv.Canvas.Font.Size := Round(9.0 * sc);

  Tv.Canvas.Pen.Width := Round(Sc * 1);

  x := Round(10.0 * sc); // 7.2
  y := Round((9.0) * 15 * sc); // 8.5   * 15
  Tv.canvas.Rectangle(x - Round(3.0 * sc), y - Round(3.8 * sc), x +
    Round(67 * sc), y + Round(93 * sc));
  // Tv.canvas.Rectangle(x - Round(4.0 * sc), y - Round(4.8 * sc), x + Round(69 * sc), y + Round(95 * sc));
  c := 10;
  for i := 11 to 22 do
  begin // ***** Cuadro de posicion de las Casas *****
    if (i < 14) or (i > 19) then
    begin // La mitad de las casas
      c := c + 1;
      if i = 11 then
      begin // Ascendente
        cad := 'As'; // chr(80);
      end
      else if i = 20 then
      begin
        cad := 'Mc'; // chr(81);
      end
      else
      begin
        Str(i - 10, cad);
      end;
      if (i > 11) and (i < 20) then
        cad := ' ' + cad;
      Tv.Canvas.TextOut(x, y, cad);
      signo := Round(trunc(longip[Rtr, i]) div 30);
      if signo > 11 then signo := 11; //???
      Dibuja_Signo(False, Tv, sb, x + Round(37.5 * sc), y, signo + 1, tm);
      // 34
      j := Trunc(longip[Rtr, i] - Trunc(signo * 30)); // grados
      Str(j, cad);
      if j < 10 then
        cad := '0' + cad;
      if imprimir then
      begin
        Tv.Canvas.Font.Color := RGBToColor(0, 0, 0);
      end
      else
      begin
        Tv.Canvas.Font.Color := RGBToColor(255, 255, 255); //(207, 207, 207);
      end;
      Tv.Canvas.TextOut(x + Round(19 * sc), y, cad);
      cad := minutozod(longip[Rtr, i]);
      Tv.Canvas.TextOut(x + Round(48 * sc), y, cad);

      //        if (i > 15) then begin
      //          x:= Round(550 * sc);
      //          y:= Round(((i-16) + 31.6) * 18 * sc);
      //        end
      //        else begin
      y := Round(((c - 10) + 9.0) * 15 * sc);  // 8.5   * 15
      //        end;
    end;
  end;

  colorPincel(imprimir, Tv);
  // Cuadro de aspectos
  tm := Round(12.0 * sc);
  Tv.Canvas.Pen.Width := Round(Sc * 1);
  Tv.Canvas.Font.Size := tm;
  cuadroAspectos(imprimir, sc, longip, Tv, sb, tm, sinas);
  colorPincel(imprimir, Tv);
  // Cuadro explicativo
  if imprimir then
    cuadroExplica(sc, Tv, sb);

  // *** Guardar grafico ***
  Radi := Tv.Height;     // !!!
  Radi2 := Tv.Width;

  if imprimir then
  begin
    // writer := TFPWriterJPEG.Create;
    // writer.CompressionQuality:= 95; //any quality here
    Tv.Picture.SaveToFile('supergrafico.jpg');
    //writer.Free; //  Tv.Picture.SaveToFile('supergrafico.bmp');
    // Tv.Picture.Free;
    // Tv.Free;
    // end
    // else begin
    //  Tv.Picture.SaveToFile('grafico.bmp');
  end;


  // !!!
   {Tv.Canvas.Refresh;
   Tv.Canvas.Clear;}

  // !!! Pendiente usar base de datos Sqlite y Freepascal (ver delicious)

    {
    // *** Para memoria ***
    // write image as png to memory stream
    Writer:=TFPWriterPNG.create;
    ms:=TMemoryStream.Create;
    writer.ImageWrite(ms,Img);   // !!!
    // write memory stream to file
    ms.Position:=0;
    fs:=TFileStream.Create('testfont.png',fmCreate);
    fs.CopyFrom(ms,ms.Size);
  // finally
    AFont.Free;
    ms.Free;
    Writer.Free;
    ImgCanvas.Free;
    Img.Free;
    fs.Free;
    }
  // *** bmp.free;

  // end; // try finally
  //__________________________________________________________________________
end;


end.
