unit syrtv;

interface

uses
  DynLibs,
  VB, tecnicas, dibujos,
  math, Printers, Dos, Classes, SysUtils, LCLIntf, LCLType,
  DateUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Grids, DBGrids, Menus, ComCtrls, ExtDlgs, Interfaces,
  EasyLazFreeType, LazFreeTypeIntfDrawer,
  // Process,
  types, upascaltz;

type
  {$IFDEF Windows}
  swe_houses = function
                   (tjdut      : double;
                    geolat     : double;
                    geolon     : double;
                    hsys       : char;
                    var hcusp0 : double;
                    var ascmc0 : double
  ) : integer; stdcall; // far; external 'swedll32.dll' name '_swe_houses@36';
  {$ELSE}
  swe_houses = function
                   (tjdut      : double;
                    geolat     : double;
                    geolon     : double;
                    hsys       : char;
                    var hcusp0 : double;
                    var ascmc0 : double
  ) : integer; cdecl;
  {$ENDIF}

  {
  DatosNatales = packed record
    Nombre: string[23];
    Sexo: string[1];
    Anio: string[4];
    Mes: string[2];
    Dia: string[2];
    Hora: string[2];
    LabOrbeMin: string[2];
    Segundos: string[2];
    AmPm: string[2];
    zona: string[5];
    HusoHor: string[3];
    HusoMin: string[2];
    LonGra: string[4];
    LonEW: string[1];
    LonMin: string[2];
    LonSeg: string[2];
    LatGra: string[3];
    LatNS: string[1];
    LatMin: string[2];
    LatSeg: string[2];
    Lugar: string[126];
    CliApel: string[30];
    CliNomb: string[25];
    Calle: string[30];
    Postal: string[10];
    Localidad: string[50];
    TelCod: string[5];
    Telefono: string[10];
    Email: string[30];
    Comentario: string[180];
  end;
  Daf = file of DatosNatales;
  }

  { TForm1 }
  pString = ^string;

  TForm1 = class(TForm)
    btnBorrar: TButton;
    btnCalcular: TButton;
    btnGuardar: TButton;
    btnSinastria: TButton;
    btnTransitos: TButton;
    btnSalir: TButton;
    btnImprimir: TButton;
    btnPrimarias: TButton;
    btnInterpretaTransit: TButton;
    CheckAhora: TCheckBox;
    CheckTrMenores: TCheckBox;
    CheckSoloLentos: TCheckBox;
    CheckMenores: TCheckBox;
    DialogDate: TCalendarDialog;
    ComboEW: TComboBox;
    ComboNombre: TComboBox;
    ComboNS: TComboBox;
    ComboPais: TComboBox;
    ComboSinastria: TComboBox;
    LabFechaTrans: TLabel;
    LabOrbeNatal: TLabel;
    LabOrbeMinutos: TLabel;
    txOrbMin: TEdit;
    txOrbGrad: TEdit;
    GroupBoxOrbes: TGroupBox;
    LabColoreaDatos: TLabel;
    LabColoreaTecnicas: TLabel;
    LabOrbeGrados: TLabel;
    listAspectos: TListBox;
    RadioButton1: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    TabSheet3: TTabSheet;
    txLugar: TEdit;
    ListLugar: TListBox;
    TvAsp: TImage;
    labAyuda: TLabel;
    LabDiasTrans: TLabel;
    LabFecha: TLabel;
    LabHora: TLabel;
    LabHuso: TLabel;
    LabLatitud: TLabel;
    LabLongitud: TLabel;
    LabLugar: TLabel;
    LabNombre: TLabel;
    labRaya: TLabel;
    PageControl2: TPageControl;
    Panel1: TPanel;
    Pr: TImage;
    rbFemenino: TRadioButton;
    rbMasculino: TRadioButton;
    sb: TImage;
    ScrollBox1: TScrollBox;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Tv: TImage;
    txAnio: TEdit;
    txDia: TEdit;
    txDiasTrans: TEdit;
    txFechaFuturo: TEdit;
    txHora: TEdit;
    txHusohoras: TEdit;
    txHusominutos: TEdit;
    txLatgra: TEdit;
    txLatmin: TEdit;
    txLongra: TEdit;
    txLonmin: TEdit;
    txMes: TEdit;
    txMinutos: TEdit;
    txSegundos: TEdit;
    txZona: TEdit;

    procedure btnBorrarClick(Sender: TObject);
    procedure btnCalcularClick(Sender: TObject);
    procedure btnGuardarClick(Sender: TObject);
    procedure btnImprimirClick(Sender: TObject);
    procedure btnPrimariasClick(Sender: TObject);
    procedure btnSalirOnClick(Sender: TObject);
    procedure btnTransitosClick(Sender: TObject);
    procedure btnSinastriaClick(Sender: TObject);
    procedure btnInterpretaTransitClick(Sender: TObject);
    procedure bttGuardarOrbeClick(Sender: TObject);
    procedure CheckAhoraOnClick(Sender: TObject);
    procedure CheckMenoresOnClick(Sender: TObject);
    procedure CheckSoloLentosChange(Sender: TObject);
    procedure CheckTrMenoresChange(Sender: TObject);
    procedure ComboNombreAyuda(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure ComboNombreChange(Sender: TObject);
    procedure ComboPaisOnExit(Sender: TObject);
    procedure ComboPaisOnMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure FormCreate(Sender: TObject);
    procedure ListAspectosOnClick(Sender: TObject);
    procedure ListLugarOnClick(Sender: TObject);
    procedure PageControl2Change(Sender: TObject);
    procedure OnPaint(Sender: TObject);
    procedure OnResize(Sender: TObject);
    procedure rad10OnClick(Sender: TObject);
    procedure rad11OnClick(Sender: TObject);
    procedure rad12OnClick(Sender: TObject);
    procedure rad1OnClick(Sender: TObject);
    procedure rad2OnClick(Sender: TObject);
    procedure rad3OnClick(Sender: TObject);
    procedure rad4OnClick(Sender: TObject);
    procedure rad5OnClick(Sender: TObject);
    procedure rad6OnClick(Sender: TObject);
    procedure rad7OnClick(Sender: TObject);
    procedure rad8OnClick(Sender: TObject);
    procedure rad9OnClick(Sender: TObject);
    procedure txFechaFuturoOnExit(Sender: TObject);
    procedure txOrbGradChange(Sender: TObject);
    procedure txLugarOnChange(Sender: TObject);
    procedure txLugarOnEnter(Sender: TObject);
    procedure TxLugarOnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure txOrbMinChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  //listaLugares,
  longip: LongPl;
  declp: DeclinPl;
  Vel: VL;
  TrMenores, SoloLentos, ahora, nuevo, sinastria: boolean;
  //*************
  listado: TStringList;
  listaPaises: TStringList;
  localizada: boolean;
const graficoBMP = False;
procedure ListaGente;
procedure rellenaDatos();
//procedure regionaPaises;

implementation

function transforma(var tx: WideString): olevariant;
const
  //*** Convierte abrev. de mes a numero
  nmes: WideString = 'JanFebMarAprMayJunJulAugSepOctNovDec';
var
  Dt: array of string;
  Mes: WideString;
  cad: string;
  cd: string;
  sit: SizeInt;
  cifra: double;
  A: double;
  m: double;
  D: double;
  h: double;
  n: double;
  s: double;
begin
  Dt := vbSplit(tx, ',');
  Mes := Copy(Dt[0], 4, 3);
  sit := vbInstr(UpperCase(nmes), Mes);
  if (sit = 0) then
  begin
    Result := 'NO';
  end;
  sit := Trunc((sit + 2) / 3); // !!! Trunc
  //*** Pasa fecha y hora del cambio a djd ***
  Val(Copy(Dt[0], 8, 4), A);
  m := double(variant(sit));
  Val(Copy(Dt[0], 1, 2), D);
  Val(Copy(Dt[1], 1, 2), h);
  Val(Copy(Dt[1], 4, 2), n);
  cifra := Lapso(A, m, D, h, n, 0);
  //!!! cifra := cifra + 364.5 + 2415020;
  //cifra = (cifra * 360) + 759
  //*** Pasa horas respecto a GMT
  Val(Copy(Dt[2], 1, 3), h);
  Val(Copy(Dt[2], 4, 2), n);
  Val(Copy(Dt[2], 6, 2), s);
  cad := vbStr(cifra);
  if (h >= 0) then
  begin
    s := ((Abs(h) * 3600) + (n * 60) + s);
  end
  else
  begin
    s := -1 * ((Abs(h) * 3600) + (n * 60) + s);
  end;
  cad := cad + ',';
  cd := vbStr(s);
  Result := cad + cd;
end;

function replace(palabra,que,con:string):string;
begin
  replace:=StringReplace(palabra,que,con,[rfReplaceAll, rfIgnoreCase]);
end;

procedure compruebaPais();
var
  j,i: integer;
  pais: string;
begin
  With Form1 do begin
    pais:= ComboPais.text;
    nuevo:= True;
    j:=ComboPais.Items.Count;
    for i:=0 to j-1 do begin
      if (pais = ComboPais.Items[i]) then begin
        nuevo:= False;
        exit;
      end;
    end;
  end;
end;

function sLugares():boolean;
// Comprueba si el lugar existe
var
  pais, lugar, region, sLinea: string;
  ps: integer;
  f: TextFile;
  encontrado: boolean;
  //--------------------------
  pv: array of string;
  ciu, nam,camino: string;
begin
  with Form1 do begin
    ListLugar.Clear;
    ps:=ComboPais.ItemIndex;
    //if (ps = -1) then begin
    compruebaPais();
    if (nuevo = True) then begin
      listLugar.Visible:=False;
      // if (nuevo = True) then ShowMessage('[Pais no encontrado]');
      ShowMessage('[Pais no encontrado]');
      sLugares := False;
      exit;
    end;
    Screen.Cursor := crHourGlass;
    pv:=vbSplit(listapaises[ps],'/');
    pais:=Trim(pv[1]);
    camino:=ExtractFilePath(Application.ExeName)+SetDirSeparators('geo/')+pais+'.txt';
    AssignFile(F, camino);
    Reset(F);
    // SL := TStringList.Create;
    ciu:=Trim(Form1.txLugar.Text);
    ciu:=UpperCase(ciu);
    encontrado:=False;
    while not EOF(F) do begin
      // Application.ProcessMessages; (No deja escribir)
      ReadLn(F, sLinea);
      pv:=vbSplit(sLinea,chr(9));// Tab
      nam:=UpperCase(Trim(pv[1]));
      if (ciu <> nam) then
        nam:=UpperCase(Trim(pv[2])); // Probamos sin acentos
      if (ciu = nam) then begin
         region:=Trim(pv[10]);//dameRegion(pais,Trim(pv[10]));
         camino :=pv[1]+','+region+','+pv[4]+','+pv[5]+','+pv[17];
         encontrado :=True;
      end;
      // SL.Add(nam);
    end;
    CloseFile(F);
    nuevo:=True;
    Screen.Cursor := crDefault;
  end;
  if (encontrado = False) then ShowMessage('[Localidad no encontrada]');
  sLugares := encontrado;
end;

function revisaDatos():boolean;
var
  siFecha: boolean;
  anio:Word;
begin
  siFecha:=True;
  with Form1 do begin
    if (ListLugar.Visible = True) then begin
      ShowMessage('[Selecciona un lugar de la lista]');
      revisaDatos:=False;
      exit;
    end;
    anio:=vbVal(txAnio.Text);
    if (anio < 1) then anio :=1;
    siFecha:=IsValidDate(anio, vbVal(txMes.Text), vbVal(txDia.Text));
    if (sifecha = False) then begin
      ShowMessage('[Fecha no válida]');
      revisaDatos:=siFecha;
      exit;
    end;
    siFecha:=IsValidTime(vbVal(txHora.Text), vbVal(txMinutos.Text), vbVal(txSegundos.Text),0);
    if (sifecha = False) then begin
      ShowMessage('[Hora no válida]');
      revisaDatos:=siFecha;
      exit;
    end;
  end; // width
  revisaDatos:=siFecha;
end;

procedure selecLugares;
var
  pais, lugar, region, sLinea: string;
  f: TextFile;
  encontrado: boolean;
  //--------------------------
  pv: array of string;
  ps: integer;
  ciu, nam,camino: string;
begin
  with Form1 do begin
    ListLugar.Clear;
    ps:=ComboPais.ItemIndex;
    if (ps = -1) then begin
      listLugar.Visible:=False;
      if (nuevo = True) then
        ShowMessage('[Pais no encontrado]');
        exit;
    end;
    Screen.Cursor := crHourGlass;
    pv:=vbSplit(listapaises[ps],'/');
    pais:=Trim(pv[1]);
    camino:=ExtractFilePath(Application.ExeName)+SetDirSeparators('geo/')+pais+'.txt';
    AssignFile(F, camino);
    Reset(F);
    // SL := TStringList.Create;
    ciu:=Trim(Form1.txLugar.Text);
    ciu:=UpperCase(ciu);
    ps:=length(ciu);
    encontrado:=False;
    while not EOF(F) do begin
      // Application.ProcessMessages; (No deja escribir)
      ReadLn(F, sLinea);
      pv:=vbSplit(sLinea,chr(9));// Tab
      nam:=UpperCase(Trim(pv[1]));
      nam:=vbLeft(nam,ps);
      if (ciu <> nam) then
        nam:=UpperCase(Trim(pv[2])); // Probamos sin acentos
      if (ciu = nam) then begin
         region:=Trim(pv[10]);//dameRegion(pais,Trim(pv[10]));
         camino :=pv[1]+','+region+','+pv[4]+','+pv[5]+','+pv[17];
         Form1.ListLugar.Items.Add(camino);
      end;
      // SL.Add(nam);
    end;
    CloseFile(F);
    //!!! nuevo:=True;
    Screen.Cursor := crDefault;
  end;
end;

function dame_horario(var Lap: double; var Zona: WideString;
  var longeo: double): single;
const
  ArchivoHora = 'hora.ini';
var
  // data : widestring;
  mensa: WideString;
  mensa2: WideString;
  sec: WideString;
  apdo: WideString;
  i: smallint;
  laj: double;
  Lak: double;
  Dt: array of string;
  dameh: single;
  dato: WideString;
begin
  sec := Zona;
  for i := 0 to 300 do
  begin
    Str(i, apdo);
    apdo := Trim(apdo);
    mensa := readINI(ArchivoHora, sec, apdo, '');
    mensa := UpperCase(mensa);
    if (mensa = '') then
    begin
      mensa := mensa2;
    end;
    dato := transforma(mensa);
    Dt := vbSplit(dato, ',');
    laj := vbVal(Dt[0]); // Val( Dt[0],laj);
    if ((laj > Lap) and (Lap > Lak)) or (mensa = mensa2) then
    begin
      if (i = 1) then
      begin
                {
                if ( dat.LonEW = 'E' ) then begin
                  i := -1;
                end;
                }
        dameh := i * longeo / 15;
        //( ( Val( dat.LonGra ) + ( Val( dat.LonMin ) / 60 ) ) / 15 );
        // dat.Zona := 'LMT';
        Zona := 'LMT';
      end;
      Result := dameh;
      exit;
    end;
    Lak := laj;
    dameh := -1 * (vbVal(Dt[1]) / 3600);
    mensa2 := mensa;
    // end;
  end;
  Result := 99999;
end;

procedure ListaGente; // Quitar de natal.txt el primer "|"
var
  f: TextFile;
  tx: array of string;
  sLinea: string;
begin
  listado := TStringList.Create;
  Form1.ComboNombre.Items.Clear;
  Form1.ComboSinastria.Items.Clear;
  AssignFile(F, ExtractFilePath(Application.ExeName) + 'natales.txt');
  Reset(F);
  // Cadena:='';
  while not EOF(F) do
  begin
    Application.ProcessMessages;
    ReadLn(F, sLinea);
    listado.Add(sLinea);
    // Cadena:=Cadena+sLinea;
    tx := vbSplit(sLinea, ',');
    if ((Length(tx[0]) > 2)) then
    begin // and (n > 2) then begin
      Form1.ComboNombre.Items.Add(tx[0]);
      Form1.ComboSinastria.Items.Add(tx[0]);
    end;
  end;
  {
  i := 0;
  r := 0;
  n := 0;
  p1 := 1;
  while(p1 > 0) do begin
      cad := RightStr(Cadena, Length(Cadena) - (r + n));
      if (p1 > 1) then begin
        p1:= vbInstr(cad,'|') - 1;
      end
      else begin
        p1:= vbInstr(cad,'|');
      end;
      r := r + p1;
      if (p1 >0) then begin
          registro:= LeftStr(cad, p1);


          // registro:=AnsiToUTF8(registro); // No funciona
          // registro:=SysToUTF8(registro);  // No funciona

          tx := vbSplit(registro, ',');
          if( (Length(tx[0]) > 2) ) then begin // and (n > 2) then begin
              Form1.ComboNombre.Items.Add(tx[0]);
              listado.Add(registro);
              i:= i + 1;
          end;
      end;
      n := n + 1;
  end;
  }
  CloseFile(F);
end;

{ TForm1a }
procedure calculaDibujar(imprimir, calcular: boolean);
var
  s, txt, ad, fs: string;
  i, Rtr: integer;
  // AProcess: TProcess;
  AStringList: TStringList;
  StartTime: TDateTime;
  f: TextFile;
  longi: LongPl;
  inic: integer;
  hora, minutos, segundos: integer;
  fecha, di, me, an, sh, sm, sg, geolon, geolat: string;
  lap, longeo, latgeo, gr, rg, ob, din, men, ann: double;
  dt,lonstr: array of string;

  astro_Handle:TLibHandle=dynlibs.NilHandle;
  swCalc: swe_calc;
  res: longint;
  xx : array [0..5] of double;
  sErr: array[0..255] of char;

  swHous: swe_houses;
  hcusps: array[0..12] of double;
  ascmc: array[0..9] of double;

begin
  // Form1.listaTec.Visible := False;
  s:= Application.Location;
  {$IFDEF Windows}
    astro_Handle := LoadLibrary(s + 'swedll32.dll');
    swCalc := swe_calc(GetProcedureAddress(astro_Handle, '_swe_calc@24'));
    // A partir de v2.01 "_swe_calc@24" se convierte en "swe_calc"
  {$ELSE}
    astro_Handle := LoadLibrary(s + 'libswe.so');
    swCalc := swe_calc(GetProcedureAddress(astro_Handle, 'swe_calc'));
  {$ENDIF}
  with Form1 do
  begin
    hora := vbVal(txHora.Text) + vbVal(txHusohoras.Text);
    minutos := vbVal(txMinutos.Text) + vbVal(txHusominutos.Text);
    segundos := vbVal(txSegundos.Text);
    if hora < 0 then begin
      hora := hora + 24;
      din := vbVal(txDia.Text) - 1;
      men := vbVal(txMes.Text);
      ann := vbVal(txAnio.Text);
      lap := lapso(ann, men, din, 0.0, 0.0, 0.0);
      fecha := Juliano_Actual(lap);
      dt := vbSplit(Fecha, '/');
      di := dt[0];
      me := dt[1];
      an := dt[2];
    end
    else if hora > 23 then begin
      hora := hora - 24;
      din := vbVal(txDia.Text) + 1;
      men := vbVal(txMes.Text);
      ann := vbVal(txAnio.Text);
      lap := lapso(ann, men, din, 0.0, 0.0, 0.0);
      fecha := Juliano_Actual(lap);
      dt := vbSplit(Fecha, '/');
      di := dt[0];
      me := dt[1];
      an := dt[2];
    end
    else begin // Formato de hora correcto
      di := txDia.Text;
      me := txMes.Text;
      an := txAnio.Text;
    end;
    if ahora then begin // <<< Carta de ahora
      StartTime := Now;
      StartTime := dateutils.LocalTimeToUniversal(StartTime);
      s:= FormatDateTime('DD,MM,YYYY',StartTime); //DateToStr(StartTime);
      dt := vbSplit(s, ',');
      di := dt[0];
      me := dt[1];
      an := dt[2];
      s:=TimeToStr(StartTime);
      dt := vbSplit(s, ':');
      hora := vbVal(dt[0]);
      minutos := vbVal(dt[1]);
      segundos := vbVal(dt[2]);
    end;
    Str(hora, sh);
    Str(minutos, sm);
    if minutos < 10 then
      sm := '0' + sm;
    longeo := vbVal(TxLongra.Text) + (vbVal(TxLonmin.Text) / 60);
    if ComboEW.Text = 'W' then begin
       longeo := -longeo;
    end;
    latgeo := vBVal(TxLatgra.Text) + vBVal(TxLatmin.Text)/60;
    if ComboNS.Text = 'S' then begin
       latgeo := -latgeo;
    end;

    if sinastria then Rtr := 1 else Rtr := 0;
    if calcular then begin
      din := vbVal(di);
      men := vbVal(me);
      ann := vbVal(an);
      lap := lapso(ann, men, din, hora + 0.0, minutos + 0.0, segundos + 0.0);
      rg:=3.1415926535/180;
      gr:= 1/rg;
      ob:= Obliq(lap)* rg; // Ob en radianes
      for i:= 0 to 9 do begin
        res:= swCalc(lap,i,SEFLG_MOSEPH + SEFLG_SPEED,xx[0],sErr);
        longi[Rtr, i]:=xx[0];
        Vel[Rtr, i] :=xx[3];
        longip[Rtr, i] := longi[Rtr, i];
        res:= swCalc(lap,i,SEFLG_MOSEPH + SEFLG_SPEED + SEFLG_EQUATORIAL,xx[0],sErr);
        declp[i]:= xx[1];
      end;

      // Nodo real:
      i:=10;
      res:= swCalc(lap,11,SEFLG_MOSEPH + SEFLG_SPEED,xx[0],sErr);
      longi[Rtr, i]:=xx[0];
      Vel[Rtr, i] :=xx[3];
      longip[Rtr, i] := longi[Rtr, i];
      res:= swCalc(lap,11,SEFLG_MOSEPH + SEFLG_SPEED + SEFLG_EQUATORIAL,xx[0],sErr);
      declp[i]:= xx[1];

    s:= Application.Location;
    {$IFDEF Windows}
      astro_Handle := LoadLibrary(s + 'swedll32.dll');
      swHous := swe_houses(GetProcedureAddress(astro_Handle, '_swe_houses@36'));
    {$ELSE}
      astro_Handle := LoadLibrary(s + 'libswe.so');
      swHous := swe_houses(GetProcedureAddress(astro_Handle, 'swe_houses'));
    {$ENDIF}
      res:= swHous(lap, latgeo, longeo, 'T', hcusps[0], ascmc[0]); // <<<-
      for i:= 11 to 22 do begin
        longi[Rtr, i]:=hcusps[i-10];
        longip[Rtr, i] := longi[Rtr, i];
      end;
      //*** Declinación de A.S., M.C. y casas
      for i := 11 To 22 do begin
        declp[i]:= (ArcSin(Sin(ob) * Sin(longi[Rtr, i] * rg))) * gr;
      end;
      UnloadLibrary(astro_Handle);
    end; // if calcular
    if sinastria then begin
      txt := ComboSinastria.Text;
    end
    else begin
      txt := ComboNombre.Text;
    end;
    if ahora then begin // Carta de ahora <<<
      txt := 'Ahora';
      s:= FormatDateTime('DD,MM,YYYY',Now);
      dt := vbSplit(s, ',');
      di := dt[0];
      me := dt[1];
      an := dt[2];
      txt:= txt + ',' + dt[0] + ',' + dt[1] + ',' + dt[2];
      s:=TimeToStr(Now);
      dt := vbSplit(s, ':');
      hora := vbVal(dt[0]);
      minutos := vbVal(dt[1]);
      segundos := vbVal(dt[2]);
      txt := txt + ',' + FormatFloat('00',Trunc(hora)) + ',' + FormatFloat('00',Trunc(minutos)) + ',';
      txt := txt + ',' + ',' + txZona.Text + ',' + TxLugar.Text;
    end // Ahora
    else begin
      txt := txt + ',' + txDia.Text + ',' + txMes.Text + ',' + TxAnio.Text;
      txt := txt + ',' + txHora.Text + ',' + txMinutos.Text + ',' + txHusohoras.Text;
      txt := txt + ',' + txHusoMinutos.Text + ',' + txZona.Text + ',' + TxLugar.Text;
    end;
    txt := txt + ',' + ComboPais.Text + ',' + txLongra.Text + ',' + ComboEW.Text;
    txt := txt + ',' + txLonmin.Text + ',' + txLatgra.Text + ',' +
      ComboNS.Text + ',' + txLatmin.Text;

    if imprimir then
    begin
      Pr.Width := 2575; // 2575, 2400;
      Pr.Height := 2991;
      dibujaCarta(Rtr, Pr.Width, Pr.Height, longip, Vel, Pr, txt, imprimir, sb);
      imprimir := False;
    end
    else
    begin
      if graficoBMP then begin
        Tv.Width := 1344;  // Trunc(Round(Form1.Width * 1.32)); // 1344, 800;
        Tv.Height := 1550; // Trunc(Round(Form1.Height * 2.1)); // 1550, 1560, 997;
      end;
      dibujaCarta(Rtr, Tv.Width, Tv.Height, longip, Vel, Tv, txt, imprimir, sb);
    end;

  end; // With Form1
  if sinastria then begin
    sinastria:= False;
    rellenaDatos();
    Form1.ListLugar.Visible:= False;
  end;
end;

procedure guardarDatos();
var
  LabOrbeMin, i, numgente: integer;
  nb, smin, maenos, registro, opMF, forigen, fdestino: string;
  f: TextFile;
  td: array of string;
begin
  with Form1 do
  begin
    numgente := listado.Count;
    forigen := ExtractFilePath(Application.ExeName) + 'natales.txt';
    fdestino := ExtractFilePath(Application.ExeName) + 'natal2.txt';
    if rbMasculino.Checked = True then
    begin
      opMF := 'M';
    end
    else
    begin
      opMF := 'F';
    end;
    nb := Trim(ComboNombre.Caption);
    registro := Concat(ComboNombre.Caption, ',', opMF, ',', txAnio.Text,
      ',', txMes.Text, ',', txDia.Text, ',', txHora.Text, ',',
      txMinutos.Text, ',', txSegundos.Text, ',,', txHusohoras.Text,
      ',', txHusominutos.Text, ',', txZona.Text, ',', TxLugar.Text,
      ',', ComboPais.Caption, ',', txLatgra.Text, ',', ComboNS.Caption,
      ',', txLatmin.Text, ',', txLongra.Text, ',', ComboEW.Caption,
      ',', txLonmin.Text, ', , , , , , , ,N');
    listado.Add(registro);
    AssignFile(f, fdestino);
    Rewrite(f);
    Screen.Cursor := crHourglass;
    for i := 0 to numgente - 1 do
    begin
      Application.ProcessMessages;
      td := vbSplit(listado[i], ',');
      if Trim(td[0]) <> nb then
      begin  // Por si Modifica sus datos
        WriteLn(f, listado[i]);
    {end
    else begin}
      end;
    end;
    WriteLn(f, registro);
    CloseFile(f);
    deletefile(forigen);
    rename(f, forigen);
    listagente(); // Actualizar lista
    if not localizada then
    begin
      forigen := ComboPais.Text;
      registro := TxLugar.Text + ',';
      LabOrbeMin := round(VbVal(txLatmin.Text) / 0.006);
      if ComboNS.Caption = 'S' then
      begin
        maenos := ' -';
      end
      else
      begin
        Maenos := ' ';
      end;
      registro := registro + maenos + Trim(TxLatgra.Text) + '.';
      Str(LabOrbeMin, smin);
      // smin:= Trim(vbStr(LabOrbeMin));

      if ComboEW.Caption = 'W' then
      begin
        maenos := ' -';
      end
      else
      begin
        Maenos := ' ';
      end;

      registro := registro + smin + ',' + maenos + Trim(TxLongra.Text) + '.';
      LabOrbeMin := round(VbVal(txLonmin.Text) / 0.006);
      Str(LabOrbeMin, smin);
      registro := registro + smin + ',-,' + txZona.Text; // !!! "CET <> Madrid"
      fdestino := TxLugar.Text;
      writeINI('atlas.ini', forigen, fdestino, registro);
    end;
    Screen.Cursor := crDefault;
    ShowMessage('[Datos guardados]');
  end; // With
end;

procedure TForm1.btnCalcularClick(Sender: TObject);
var
  buenFormato: boolean;
begin
  compruebaPais();
    if (nuevo = True) then begin
       listLugar.Visible:=False;
      // if (nuevo = True) then ShowMessage('[Pais no encontrado]');
      ShowMessage('[Pais no encontrado]');
      exit;
    end;

  buenFormato:=revisaDatos() and sLugares();
  if (buenFormato) then begin
    // if nuevo then guardarDatos(); // !!! Si deseas que guarde automaticamente
    sinastria := False;
    rellenaDatos(); // datos natales (no de sinastria)
    calculaDibujar(False,True);
  end;
end;

procedure TForm1.btnGuardarClick(Sender: TObject);
  var
    buenFormato: boolean;
begin
  buenFormato:=revisaDatos() and sLugares();
  if (buenFormato) then guardarDatos();
end;

procedure hazImpresion();
const
  x = 60;
  y = 20;
begin
  calculaDibujar(True, False);
  {
  Printer.BeginDoc;
  Printer.Canvas.Draw(x, y, Form1.Pr.Picture.Bitmap);
  Printer.EndDoc;
  }
  // Printer.Free;
  // Form1.Pr.Picture.Bitmap.Free;
  // FreeAndNil(Printer);
  // FreeAndNil(Form1.Pr.Picture.Bitmap);

end;

procedure TForm1.btnImprimirClick(Sender: TObject);
begin
  hazImpresion();
end;

procedure TForm1.btnSalirOnClick(Sender: TObject);
begin
  FreeAndNil(listado);
  Close;
end;

function simbolo(fig:string):integer;
var
  nbp: string;
  pcd: integer;
begin
  nbp:='Sol,Lun,Mer,Ven,Mar,Jup,Sat,Ura,Nep,Plu,Nod,Asc,M.C';
  pcd:=vbInstr(nbp,fig);
  if (pcd = 1) then begin
    simbolo:=0;
  end
  else begin
    simbolo:= Trunc((pcd-1)/4);
  end;
end;
function simboloPareja(fig:string):integer;
var
  nbp: string;
  dnp: array of string;
  i, np: integer;
begin
  nbp:='Sol,Luna,Mercurio,Venus,Marte,Júpiter,Saturno,Urano,Neptuno,Plutón,Nodo_Lunar,Ascendente,Medio_Cielo';
  dnp:=vbSplit(nbp,',');
  np:=-1;
  for i:=0 to 12 do begin
    if (Trim(fig) = Trim(dnp[i])) then begin
      np:=i;
      break;
    end;
  end;
  simboloPareja:= np;
end;

procedure listaTecnicas(op: integer);
var
  f: TextFile;
  np, tx, tx2, nb1, nb2: string;
  nbp: array of string;
  contador, ini, fin, fig, tam, distancia: integer;
  sc: single;
  py: longint;
  fn: TFreeTypeFont;
begin
  if op = 1 then
  begin
    AssignFile(F, ExtractFilePath(Application.ExeName) + 'transitos.txt');
  end
  else if op = 2 then
  begin
    AssignFile(F, ExtractFilePath(Application.ExeName) + 'sinastria.txt');
  end;
  Reset(f);
  // Aspectos en plan grafico
  contador := 0;
  while not EOF(f) do
  begin
    Application.ProcessMessages;
    ReadLn(f, tx);
    nbp := vbSplit(tx, ' ');
    if ((Length(nbp[0]) > 1)) then
    begin
      contador := contador + 1;
    end;
  end;
  Form1.TvAsp.Picture.Bitmap.SetSize(Form1.TvAsp.Width, contador * 20);
  Form1.TvAsp.Height:= (contador) * 20;
  Form1.TvAsp.Canvas.Clear;
  Form1.TvAsp.Canvas.Brush.Color:=RGBToColor(255,255,255);
  Form1.TvAsp.Canvas.FillRect(Form1.TvAsp.BoundsRect);
  SetBkMode(Form1.TvAsp.Canvas.Handle, TRANSPARENT);
  Form1.TvAsp.Canvas.Pen.Width:=1;
  Form1.TvAsp.Canvas.Font.Size:=8;
  contador := 0;
  Reset(f);
  while not EOF(f) do
  begin
    Application.ProcessMessages;
    ReadLn(f, tx);
    nbp := vbSplit(tx, ' ');
    if ((Length(nbp[0]) > 1)) then
    begin
      contador := contador + 1;
      py:=((contador -1) * 20) +1;
      if (op = 1) then begin // Transitos
        Form1.TvAsp.Canvas.Textout(1, py+3, nbp[0]);
        fig:=simbolo(nbp[1]);
        Dibuja_Planeta(False,Form1.TvAsp,Form1.sb,60,py,fig, 13);
        tam:=12;
        sc:=1;
        distancia:=vbVal(nbp[2]);
        Form1.TvAsp.Canvas.Pen.Color:=RGBToColor(0,0,0);
        Form1.TvAsp.Canvas.Pen.Width:=1;
        simboloAspecto(Form1.TvAsp,76,py+5,tam,distancia, sc);
        fig:=simbolo(nbp[3]);
        Dibuja_Planeta(False,Form1.TvAsp,Form1.sb,88,py,fig, 13);
        Form1.TvAsp.Canvas.Textout(106, py+3, nbp[4]); // inicio>fin 104
        if (nbp[2] <> '999') and (nbp[2] <> '909') then begin
          Form1.TvAsp.Canvas.Textout(181, py+3, nbp[9]); // Hora
        end;
        if (nbp[7] <> '(.)') then begin
          ini:=vbInstr(nbp[7],'(');
          fin:=vbInstr(nbp[7],')');
          np:=Copy(nbp[7], ini+1, (fin-ini)-1); // Mid
          distancia:=vbVal(np);
          Form1.TvAsp.Canvas.Pen.Color:=RGBToColor(0,0,0);
          Form1.TvAsp.Canvas.Pen.Width:=1;
          simboloAspecto(Form1.TvAsp,214,py+5,tam,distancia, sc);// Repite asp
        end;
      end
      else begin // Sinastria
        if (contador = 1) then begin
          nb1:=Form1.ComboNombre.Text;
          nb2:=Form1.ComboSinastria.Text;
          ini := vbInstr(nb1,' ');
          if (ini > 0) then nb1:=Copy(nb1,1,ini);
          ini := vbInstr(nb2,' ');
          if (ini > 0) then nb2:=Copy(nb2,1,ini);
        end;
        Form1.TvAsp.Canvas.Textout(3, py+3, nb1);
        fig:=simboloPareja(nbp[0]);
        Dibuja_Planeta(False,Form1.TvAsp,Form1.sb,69,py,fig, 13);
        tam:=12;
        sc:=1;
        distancia:=vbVal(nbp[1]);
        Form1.TvAsp.Canvas.Pen.Color:=RGBToColor(0,0,0);
        Form1.TvAsp.Canvas.Pen.Width:=1;
        simboloAspecto(Form1.TvAsp,95,py+5,tam,distancia, sc);
        fig:=simboloPareja(nbp[2]);
        Dibuja_Planeta(False,Form1.TvAsp,Form1.sb,117,py,fig, 13);
        Form1.TvAsp.Canvas.Textout(140, py+3, nb2);
      end; // Transitos
      if op = 1 then
        tx := nbp[0];
      np := nbp[1];
      if np = 'Ura' then
        tx := '* ' + tx;
      if np = 'Nep' then
        tx := '* ' + tx;
      if np = 'Plu' then
        tx := '* ' + tx;
      // Form1.listaTec.Items.Add(tx);// Sinastria y fecha exacta de transitos
      if op = 1 then
      begin
        tx2 := nbp[1] + ' ' + nbp[2] + ' ' + nbp[3] + ' ' + nbp[4] + ' ' + nbp[7];
        // Form1.listaTec.Items.Add(tx2);
         {
         Form1.listaTec.Canvas.Pen.Color:=RGBToColor(0,0,0);
         Form1.listaTec.Canvas.EllipseC(20,20,35,35);
         }
      end;
    end;
  end;
  Closefile(f);
  // Form1.listaTec.Visible := True;
end;

procedure TForm1.btnPrimariasClick(Sender: TObject);
var
  hora, LabOrbeMin:integer;
  lap, longeo, latgeo, din, men, ann:double;
  di, me, an, sh, sm, fecha: string;
  dt : array of string;
begin
  Screen.Cursor := crHourglass;
  hora := vbVal(txHora.Text) + vbVal(txHusohoras.Text);
  LabOrbeMin := vbVal(txMinutos.Text) + vbVal(txHusominutos.Text);
  if hora < 0 then begin
      hora := hora + 24;
      din := vbVal(txDia.Text) - 1;
      men := vbVal(txMes.Text);
      ann := vbVal(txAnio.Text);
      lap := lapso(ann, men, din, 0.0, 0.0, 0.0);
      fecha := Juliano_Actual(lap);
      dt := vbSplit(Fecha, '/');
      di := dt[0];
      me := dt[1];
      an := dt[2];
  end
  else if hora > 23 then begin
      hora := hora - 24;
      din := vbVal(txDia.Text) + 1;
      men := vbVal(txMes.Text);
      ann := vbVal(txAnio.Text);
      lap := lapso(ann, men, din, 0.0, 0.0, 0.0);
      fecha := Juliano_Actual(lap);
      dt := vbSplit(Fecha, '/');
      di := dt[0];
      me := dt[1];
      an := dt[2];
  end
  else begin
      di := txDia.Text;
      me := txMes.Text;
      an := txAnio.Text;
      din := vbVal(txDia.Text);
      men := vbVal(txMes.Text);
      ann := vbVal(txAnio.Text);
  end;
  Str(hora, sh);
  Str(LabOrbeMin, sm);
  if LabOrbeMin < 10 then
    sm := '0' + sm;

  lap := lapso(ann, men, din, hora * 1.0, LabOrbeMin * 1.0, 0.0);

  longeo := vbVal(TxLongra.Text) + (vbVal(TxLonmin.Text) / 60);
  if ComboEW.Text = 'W' then begin
    longeo := -longeo;
  end;
  latgeo := vBVal(TxLatgra.Text) + vBVal(TxLatmin.Text)/60;
  if ComboNS.Text = 'S' then begin
    latgeo := -latgeo;
  end;
  ListaPrimarias(txDiasTrans.Text, txFechaFuturo.Text, longip, lap, longeo, latgeo);
  Screen.Cursor := crDefault;
  //listaTecnicas(3);  // 3 Primarias
end;

procedure TForm1.btnTransitosClick(Sender: TObject);
var
  i, j: integer;
  interpreta: boolean;
begin
  Screen.Cursor := crHourglass;
  interpreta:= false;
  ListaTransitos(TrMenores, SoloLentos, txDiasTrans.Text, txFechaFuturo.Text, longip, declp, interpreta);
  Screen.Cursor := crDefault;
  // ShowMessage('[Lista de tránsitos hecha]');
  listaTecnicas(1); // Modo grafico
end;

// ********* SINASTRIA *********
procedure hazSinastria();
var
  f: TextFile;
  s, tx, ap: string;
  yo, tu, aspt, yoy, tut: integer;
  nbp: array of string;
begin
  s := 'Sol,Luna,Mercurio,Venus,Marte,Júpiter,Saturno,Urano,Neptuno,Plutón,Nodo_Lunar,Ascendente,Medio_Cielo';
  nbp := vbSplit(s, ',');
  sinastria := True;
  rellenaDatos();
  calculaDibujar(False, True);
  sinastria := True;
  AssignFile(f, ExtractFilePath(Application.ExeName) + 'sinastria.txt');
  Rewrite(f); // escritura
  tx := '';
  for yo := 0 to 12 do
  begin
    yoy := yo;
    if yo = 12 then
      yoy := 20;
    for tu := 0 to 12 do
    begin
      tut := tu;
      if tu = 12 then
        tut := 20;
      aspt := calcula_aspecto(Longip, yoy, tut, sinastria, 0);
      if (aspt > -1) and (aspt <> 135) and (aspt <> 45) then
      begin
        Str(aspt, ap);
        tx := nbp[yo] + ' ' + ap + ' ' + nbp[tu];
        writeln(f, tx);
      end;
    end;
  end;
  CloseFile(f);
  listaTecnicas(2);
end;

procedure TForm1.btnSinastriaClick(Sender: TObject);
begin
  ahora:=False;
  hazSinastria();
  // Form2.Show;
end;

procedure TForm1.btnInterpretaTransitClick(Sender: TObject);
var
  i, j: integer;
  interpreta: boolean;
begin
  Screen.Cursor := crHourglass;
  interpreta:= true;
  ListaTransitos(TrMenores, SoloLentos, txDiasTrans.Text, txFechaFuturo.Text, longip, declp, interpreta);
  Screen.Cursor := crDefault;
end;

procedure GuardaOrbeNatal();
var
  g, m, p, i: integer;
  astro, cadr, cadw, s: string;
  dt: array of string;
begin
with Form1 do begin
  p:= listAspectos.ItemIndex;
  g:= vbVal(txOrbGrad.Text);
  m:= vbVal(txOrbMin.Text);
  s:=FormatFloat('0.00', g + (m/60));
  s:=StringReplace(s,',','.',[rfReplaceAll, rfIgnoreCase]);
  if RadioButton1.Checked then begin
    astro:='Sol';
  end
  else if RadioButton2.Checked then begin
    astro:='Lun';
  end
  else if RadioButton3.Checked then begin
    astro:='Mer';
  end
  else if RadioButton4.Checked then begin
    astro:='Ven';
  end
  else if RadioButton5.Checked then begin
    astro:='Mar';
  end
  else if RadioButton6.Checked then begin
    astro:='Jup';
  end
  else if RadioButton7.Checked then begin
    astro:='Sat';
  end
  else if RadioButton8.Checked then begin
    astro:='Ura';
  end
  else if RadioButton9.Checked then begin
    astro:='Nep';
  end
  else if RadioButton10.Checked then begin
    astro:='Plu';
  end
  else if RadioButton11.Checked then begin
    astro:='Nod';
  end
  else if RadioButton12.Checked then begin
    astro:='Asc';
  end;
  cadr:= readINI('opciones.ini', 'orbes', astro, '0');
  dt:= vbSplit(cadr,',');
  cadw:='';
  for i:=0 to 10 do begin
      if (i=p) then begin
        cadw:= cadw + s + ',';
      end
      else begin
        cadw:=cadw + dt[i] +',';
      end;
  end;
  writeINI('opciones.ini', 'orbes', astro, cadw);
  calculaDibujar(False,True);
end; // with
end;

procedure TForm1.bttGuardarOrbeClick(Sender: TObject);
begin
  GuardaOrbeNatal();
end;

procedure TForm1.CheckAhoraOnClick(Sender: TObject);
begin
  if (CheckAhora.Checked = True) then begin
    sinastria:=false; //<<<
    ahora:= True;
  end
  else begin
    ahora:= False;
  end;
  calculaDibujar(False,True);
end;

procedure TForm1.CheckMenoresOnClick(Sender: TObject);
begin
  if (CheckMenores.Checked = True) then begin
    menores:= True;
  end
  else begin
    menores:= False;
  end;
  calculaDibujar(False,True);
end;

procedure TForm1.CheckSoloLentosChange(Sender: TObject);
begin
  if CheckSoloLentos.Checked = True then begin
    SoloLentos:=True;
  end
  else begin
    SoloLentos:= False;
  end;
end;

procedure TForm1.CheckTrMenoresChange(Sender: TObject);
begin
  if CheckTrMenores.Checked = True then begin
    TrMenores:=True;
  end
  else begin
    TrMenores:=False;
  end;
end;

procedure TForm1.ComboNombreAyuda(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  labAyuda.Caption := ' Cuando encuentres el nombre haz clic en él.';
  //labAyuda.Canvas.Rectangle(1, 1,labAyuda.Width, labAyuda.Height);
  // labAyuda.Top:= Mouse.CursorPos.Y;
  //labAyuda.Visible := True;
end;

procedure TForm1.ComboNombreChange(Sender: TObject);
begin
  rellenaDatos();
end;

procedure TForm1.ComboPaisOnExit(Sender: TObject);
begin
  //!!! nuevo:=True;
end;

procedure TForm1.ComboPaisOnMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  labAyuda.Caption :=
    ' Cuando selecciones la localidad. Pulsa en "Guardar" y luego en "Calcular" ';
  // labAyuda.Top:= Mouse.CursorPos.Y;
  //labAyuda.Visible := True;
end;

function dameHuso(yy,mm,dd,ho,mi,ss:word;zona:string):single;
var
  ptz :TPascalTZ;
  s: string;
  t,nt: TDateTime;
  ms:Word;
begin
  //Now = Tiempo transcurrido desde 1 Enero 1900
  ptz := TPascalTZ.Create();
  ptz.ParseDatabaseFromFile('tzdatabase/global');
  ms:=0;
  t:=EncodeDate(yy,mm,dd) + EnCodeTime(ho,mi,ss,ms);
  nt:=ptz.LocalTimeToGMT(t,zona);
  // s:= DateTimeToStr(nt);
  ptz.free;
  dameHuso:=(nt-t)*24.0;
end;

procedure procesaLugar(datosLugar:string);
var
  Lug: array of string;
  pais, lugar, ciudadHoraria, fs, cd: string;
  Zona: WideString;
  longeo, latgeo, Lap: double;
  ss: double;
  huso, hsmin: single;
  p: integer;
  yy,mm,dd,ho,mi,sg:word;
begin
  Lug:=vbSplit(datosLugar,',');
  Form1.txLugar.Text:= Lug[0];
  Form1.ListLugar.Clear;
  Form1.ListLugar.Visible:=False;
  ciudadHoraria:= Lug[4];
  // <- ciudadHoraria:=replace(ciudadHoraria,'_',' ');
  Val(Lug[3], longeo); // -W
  Val(Lug[2], latgeo);
  // Longitud geografica
  p := Trunc(Abs(Int(longeo)));
  cd := Format('%.3D', [p]);
  Form1.txLongra.Text := cd;
  ss := (Abs(longeo) - p) * 60.0;
  p := Round(ss);
  cd := Format('%.2D', [p]);
  Form1.txLonmin.Text := cd;
  if longeo < 0 then begin
    Form1.ComboEW.Text := 'W';
  end
  else begin
    Form1.ComboEW.Text := 'E';
  end;
  // Latitud geografica
  p := Trunc(Abs(Int(latgeo)));
  cd := Format('%.2D', [p]);
  Form1.txLatgra.Text := cd;
  ss := (Abs(latgeo) - p) * 60.0;
  p := Round(ss);
  cd := Format('%.2D', [p]);
  Form1.txLatmin.Text := cd;
  if latgeo < 0 then begin
    Form1.ComboNS.Text := 'S';
  end
  else begin
    Form1.ComboNS.Text := 'N';
  end;
  // Huso Horario
  yy := vbVal(Form1.txAnio.Text);
  mm := vbVal(Form1.txMes.Text);
  dd := vbVal(Form1.txDia.Text);
  ho := vbVal(Form1.txHora.Text);
  mi := vbVal(Form1.txMinutos.Text);
  sg := vbVal(Form1.txSegundos.Text);
  // Huso en horas
  huso:= dameHuso(yy,mm,dd,ho,mi,sg,ciudadhoraria);
  Str(Int(huso), fs);  // !!! Comprueba si es mejor Trunc
  cd := fs;
  p := vbInstr(fs, '.');
  fs := Copy(fs, 1, p - 1);
  Form1.txHusohoras.Text := fs;
  // Huso en LabOrbeMin
  hsmin := Frac(huso) * -60;
  // !!! Signo menos para LMT va bien. ¿Como va con husos fraccionados?
  p := Round(hsmin);
  if p = 0.0 then begin
    fs := '00';
  end
  else begin // La hora no se cambia a una hora en punto
    if Int(huso) = 0 then
      Form1.txHusohoras.Text := '0';
    Str(p, fs);
  end;
  // fs:=Copy(cd, p, Length(cd)-(p));
  Form1.txHusominutos.Text := fs;
  Form1.txZona.Text := ciudadHoraria;//UpperCase(Zona);
  localizada := True;
  Screen.Cursor := crDefault;
  // ShowMessage('[Coordenadas y Huso Horario encontrados]');
end;

procedure borrarDatos();
var
  aborrar: integer;
  i, numgente: integer;
  registro, opMF, forigen, fdestino: string;
  f: TextFile;
begin
  Screen.Cursor := crHourglass;
  aborrar := Form1.ComboNombre.Items.IndexOf(Form1.ComboNombre.Caption);
  listado[aborrar] := 'BORRAME';
  numgente := listado.Count;
  forigen := ExtractFilePath(Application.ExeName) + 'natales.txt';
  fdestino := ExtractFilePath(Application.ExeName) + 'natal2.txt';
  AssignFile(f, fdestino);
  Rewrite(f);
  for i := 0 to numgente - 1 do
  begin
    Application.ProcessMessages;
    if listado[i] <> 'BORRAME' then
    begin
      WriteLn(f, listado[i]);
    end;
  end;
  CloseFile(f);
  deletefile(forigen);
  rename(f, forigen);
  listagente(); // Actualizar lista
  Screen.Cursor := crDefault;
  ShowMessage('[Datos borrados]');
end;

procedure TForm1.btnBorrarClick(Sender: TObject);
begin
  borrarDatos();
end;
procedure rellenaOrbes();
var
  n: single;
  g,m,p: integer;
  astro, sLinea: string;
  dt: array of string;
begin
with form1 do begin
  p:= listAspectos.ItemIndex;
  if RadioButton1.Checked then begin
    astro:='Sol';
  end
  else if RadioButton2.Checked then begin
    astro:='Lun';
  end
  else if RadioButton3.Checked then begin
    astro:='Mer';
  end
  else if RadioButton4.Checked then begin
    astro:='Ven';
  end
  else if RadioButton5.Checked then begin
    astro:='Mar';
  end
  else if RadioButton6.Checked then begin
    astro:='Jup';
  end
  else if RadioButton7.Checked then begin
    astro:='Sat';
  end
  else if RadioButton8.Checked then begin
    astro:='Ura';
  end
  else if RadioButton9.Checked then begin
    astro:='Nep';
  end
  else if RadioButton10.Checked then begin
    astro:='Plu';
  end
  else if RadioButton11.Checked then begin
    astro:='Nod';
  end
  else if RadioButton12.Checked then begin
    astro:='Asc';
  end;
  sLinea := readINI('opciones.ini', 'orbes', astro, '0');
  dt := vbSplit(sLinea,',');
  n:= vbVal(dt[p]);
  txOrbGrad.Text:=FormatFloat('0', Trunc(n));
  txOrbMin.Text:=FormatFloat('0', (n-Trunc(n))*60);
end; // With
end;

procedure TForm1.FormCreate(Sender: TObject);
  var
  dt: array of string;
  Anyo, Mes, Dia, DiaSemana: word;
  ST: TSystemTime;
  hora, minuto, segundo: string;
  F: TextFile;
  sLinea: string;
  i, ultimo, ultima: integer;
  tx: array of string;
  const nbAsp='Conjunción,Semisextil,Semicuadratura,Sextil,Quintil,Cuadratura,Trígono,Sesquicuadratura,Biquintil,Quincuncio,Oposición';
begin
  {$IFDEF Windows}
    LabColoreaDatos.Visible:=True;
    LabColoreaTecnicas.Visible:=True;
  {$ENDIF}
  ahora:= False;
  menores:= False;
  LabColoreaDatos.SendToBack;
  LabColoreaTecnicas.SendToBack;
  LabColoreaTecnicas.Top:= 192;
  LabColoreaDatos.Top:= 70;
  // ComboNombre.Font.Color:=RGBToColor(250, 250, 250);
  LabAyuda.Font.Color:=RGBToColor(210, 210, 250);

  rbMasculino.Font.Color:=RGBToColor(250, 250, 250);
  rbFemenino.Font.Color:=RGBToColor(250, 250, 250);
  LabFecha.Font.Color:=RGBToColor(250, 250, 250);
  LabHora.Font.Color:=RGBToColor(250, 250, 250);
  LabLugar.Font.Color:=RGBToColor(250, 250, 250);
  LabLongitud.Font.Color:=RGBToColor(150, 150, 150);
  LabLatitud.Font.Color:=RGBToColor(150, 150, 150);
  LabHuso.Font.Color:=RGBToColor(150, 150, 150);
  CheckAhora.Font.Color:=RGBToColor(250, 250, 250);
  CheckMenores.Font.Color:=RGBToColor(250, 250, 250);
  CheckSoloLentos.Font.Color:=RGBToColor(250, 250, 250);
  CheckTrMenores.Font.Color:=RGBToColor(250, 250, 250);
  LabFechaTrans.Font.Color:=RGBToColor(250, 250, 250);
  LabDiasTrans.Font.Color:=RGBToColor(250, 250, 250);

  Form1.Width:=845;
  Form1.Height:=610;//572;
  if graficoBMP then begin
    Tv.Stretch:=True;
  end;
  listapaises:= TStringList.Create;
  localizada := True;
  ListaGente();
  DateTimeToSystemTime(Now, ST);
  Str(ST.Hour, hora);
  Str(ST.Minute, minuto);
  Str(ST.Second, segundo);

  txHora.Text := hora;
  txMinutos.Text := minuto;
  txSegundos.Text := segundo;
  GetDate(Anyo, Mes, Dia, DiaSemana);
  txAnio.Text := IntToStr(Anyo);
  txMes.Text := IntToStr(Mes);
  txDia.Text := IntToStr(Dia);
  // txFechaFuturo.Text:= LongMonthNames[Mes];//IntToStr(DiaSemana);
  txFechaFuturo.Text := txAnio.Text + '/' + txMes.Text + '/' + txDia.Text;
  AssignFile(F, ExtractFilePath(Application.ExeName) + 'av_paises.txt');
  Reset(F);
  while not EOF(F) do
  begin
    ReadLn(F, sLinea);
    listapaises.Add(sLinea);
    tx:=vbSplit(sLinea,'/');
    ComboPais.Items.Add(tx[0]);
  end;
  CloseFile(F);

  dt:= vbSplit(nbAsp,',');
  for i:=0 to 10 do begin
    listAspectos.Items.Add(dt[i]);
  end;
  listAspectos.ItemIndex := 0;
  rellenaOrbes();

  sLinea := readINI('opciones.ini', 'defecto', 'ultimo', '0');
  ultimo := vbVal(sLinea);
  Form1.ComboNombre.ItemIndex := ultimo - 1;
  rellenaDatos();
  sLinea := readINI('opciones.ini', 'defecto', 'ultima', '0');
  ultima := vbVal(sLinea);
  Form1.ComboSinastria.ItemIndex := ultima - 1;
  if graficoBMP then begin
    btnCalcularClick(Sender);
  end;
  nuevo:=False;
end;

procedure TForm1.ListAspectosOnClick(Sender: TObject);
begin
  rellenaOrbes();
end;

procedure TForm1.ListLugarOnClick(Sender: TObject);
var
  lugar:string;
  p: integer;
begin
  p:=ListLugar.ItemIndex;
  if (p >=0) then begin
    lugar:=ListLugar.Items[p];
    procesaLugar(lugar);
  end;
  ListLugar.Visible:=False;
end;

procedure TForm1.PageControl2Change(Sender: TObject);
begin
    ListLugar.Visible:= false;
end;

procedure TForm1.OnPaint(Sender: TObject);
var
  fh,fw, h,w: integer;
  sch,scw: single;
  nombre: string;
begin
  fh:=Form1.Height;
  fw:=Form1.Width;
  if graficoBMP then begin
    sch:=1.23;
    scw:=0.77;
  end
  else begin
    sch:=2.5;
    scw:=2.5;
  end;
  h:=Trunc(ClientHeight * sch);
  w:=Trunc(Clientwidth * scw);
  if (Tv.Height <> h) or (Tv.Width <> w) then begin
    Tv.Height := h;
    Tv.Width := w;
    if (not graficoBMP) then begin
      if (longip[0,7] = 0) and (longip[0,8] = 0) and (longip[0,9] = 0) then begin
      calculaDibujar(False, True);
      end
      else begin
        calculaDibujar(False, False);
      end;
    end;
  end;
end;

{procedure posMenu();
begin // procedure TForm1.GroupBox1Click(Sender: TObject);
    Form1.GroupBox1.top:= Form1.Height - Form1.GroupBox1.Height;
end;}

procedure TForm1.OnResize(Sender: TObject);
var h:integer;
begin
  h:= Form1.Height - 10;
  if (Panel1.Height <> h) then begin
    Panel1.Height := h;
    // Panel1.Width := Trunc(h/2.5);
  end;
end;

procedure TForm1.rad10OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad11OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad12OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad1OnClick(Sender: TObject);
begin
  rellenaOrbes();
end;

procedure TForm1.rad2OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad3OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad4OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad5OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad6OnClick(Sender: TObject);
begin
  rellenaOrbes();
end;

procedure TForm1.rad7OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad8OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.rad9OnClick(Sender: TObject);
begin
    rellenaOrbes();
end;

procedure TForm1.txFechaFuturoOnExit(Sender: TObject);
var
  dt : array of string;
  i,di,me:integer;
  fechaSi:boolean;
begin
  fechaSi:=True;
  dt:= vbSplit(txFechaFuturo.Text,'/');
  i:= length(dt);
  if (i <> 3) then begin
    fechaSi:=False;
  end
  else begin
    Val(dt[2],di);
    if (di < 1) or (di > 31) then fechaSi:=False;
    Val(dt[1],me);
    if (me < 1) or (me > 12) then fechaSi:=False;
    // Val(dt[0],an);
  end;
  if (fechaSi = False) then begin
    DialogDate.Date := now;
    if DialogDate.Execute then
      txFechaFuturo.Text := FormatDateTime('yyyy/mm/dd',DialogDate.Date)
    else
      txFechaFuturo.SetFocus;
  end;
end;

procedure TForm1.txOrbGradChange(Sender: TObject);
begin
  GuardaOrbeNatal();
end;

function dameRegion(pais,codigo:string):string;
var
  f: TextFile;
  nam, sLinea, camino:string;
  pv: array of string;
begin
  codigo:=pais+'.'+codigo;
  camino:=ExtractFilePath(Application.ExeName)+SetDirSeparators('/geo/')+'admin1CodesASCII.txt';
  AssignFile(F, camino);
  Reset(F);
  while not EOF(F) do begin
    ReadLn(F, sLinea);
    pv:=vbSplit(sLinea,chr(9));// Tab
    nam:=Trim(pv[0]);
    if (codigo = nam) then break;
  end;
  CloseFile(F);
  dameRegion:=Trim(pv[1]);
end;

procedure TForm1.txLugarOnChange(Sender: TObject);
 var
   p: integer;
begin
  p:= length(txLugar.Text);
  if(p > 1) then begin
    listLugar.Visible:=True;
    selecLugares();
  end
  else begin
    listLugar.Visible:=False;
  end;
end;

procedure TForm1.txLugarOnEnter(Sender: TObject);
var
 ps: integer;
 pais: string;
 {
 f: TextFile;
 encontrado: boolean;
 //--------------------------
 pv: array of string;
 ciu, nam,camino: string;
 }
begin
  // *** Comprobar que el pais existe ***
  //??? nuevo:=True;

  with Form1 do begin
    ListLugar.Clear;
    pais:=AnsiUpperCase(ComboPais.Text);
    nuevo:=True;
    for ps:= 0 to ComboPais.Items.Count - 1 do begin
      if AnsiUpperCase(ComboPais.Items[ps]) = pais then
      begin
        nuevo:= false;
        Exit;
      end;
    end;
    ps:=ComboPais.ItemIndex;
    if (nuevo = true) then begin
      listLugar.Visible:=False;

      // if (nuevo = True) then ShowMessage('[Pais no encontrado]');
      // ShowMessage('[Pais no encontrado]');
      // sLugares := False;
      // nuevo:=True;
    end;
  end;
end;

procedure TForm1.txOrbMinChange(Sender: TObject);
begin
    GuardaOrbeNatal();
end;

procedure TForm1.TxLugarOnMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  labAyuda.Caption :=
    ' Cuando selecciones la localidad. Pulsa en "Guardar" y luego en "Calcular" ';
  // labAyuda.Top:= Mouse.CursorPos.Y;
  // labAyuda.Visible := True;
end;

procedure regionaPaises();
// Inserta region/estado en archivos de paises
var
  i,j: integer;
  pvj,sLinea,pais,cad,region,camino:string;
  f,fw: TextFile;
  pv: array of string;
begin
  Screen.Cursor := crHourGlass;
  for i:=0 to listaPaises.Count do begin
    pv:=vbSplit(listapaises[i],'/');
    pais:=Trim(pv[1]);
    camino:=ExtractFilePath(Application.ExeName)+SetDirSeparators('geo/')+pais+'.txt';
    AssignFile(f, camino);
    Reset(f);
    camino:=ExtractFilePath(Application.ExeName)+SetDirSeparators('geo2/')+pais+'.txt';
    AssignFile(fw, camino);
    Rewrite(fw);
    while not EOF(f) do begin
      Application.ProcessMessages;
      ReadLn(f, sLinea);
      pv:=vbSplit(sLinea,chr(9));// Tab
      region:=dameRegion(pais,Trim(pv[10]));
      cad:='';
      for j:=0 to length(pv)-1 do begin
        if (j=10) then begin
          cad:=cad+region+chr(9);
        end
        else begin
          pvj:=pv[j];
          cad:=cad+pvj+chr(9);
        end;
      end;
      WriteLn(fw,cad);
    end;
    CloseFile(f);
    CloseFile(fw);
  end;
  Screen.Cursor := crDefault;
end;

procedure rellenaDatos();
var
  n: integer;
  tx: array of string;
  sn: string;
  Result: string;
{
timeval: TTimeVal;
timezone: PTimeZone;
aDateTime: TDateTime;
 }
begin
  // n:= Form1.ComboNombre.ItemIndex;
  nuevo := False;
  if sinastria then
  begin
    n := Form1.ComboSinastria.Items.IndexOf(Form1.ComboSinastria.Caption);
  end
  else
  begin
    n := Form1.ComboNombre.Items.IndexOf(Form1.ComboNombre.Caption);
  end;
  if n > -1 then
  begin
    Str(n + 1, sn);
    if sinastria then
    begin
      writeINI('opciones.ini', 'defecto', 'ultima', sn);
    end
    else
    begin
      writeINI('opciones.ini', 'defecto', 'ultimo', sn);
    end;
    // sn:= listado[n]; // Comprobacion, quitar
    tx := vbSplit(listado[n], ',');
    if length(tx) > 7 then
    begin
      if tx[1] = 'M' then
      begin
        Form1.rbMasculino.Checked := True;
      end
      else
      begin
        Form1.rbFemenino.Checked := True;
      end;
      with Form1 do
      begin
        txAnio.Text := tx[2];
        txMes.Text := tx[3];
        txDia.Text := tx[4];
        txHora.Text := tx[5];
        txMinutos.Text := tx[6];
        txSegundos.Text := tx[7];
        txHusohoras.Text := tx[9];
        txHusominutos.Text := tx[10];
        txZona.Text := tx[11];
        txLugar.Text:= tx[12];
        ComboPais.Caption := tx[13];
        txLatgra.Text := tx[14];
        ComboNS.Caption := tx[15];
        txLatmin.Text := tx[16];
        txLonGra.Text := tx[17];
        ComboEW.Caption := tx[18];
        txLonmin.Text := tx[19];
      end;
    end;
  end;
end;

initialization
  {$I syrtv.lrs}

end.
