unit VB;

{$mode objfpc}{$H+}

interface

uses
  INIfiles, Classes, tokenizerClass, SysUtils;

type
  TStrArray = array of string;

function vbInstr(cadena, cadbuscada: string): SizeInt;
function vbSplit(S: string; Delimiter: char): TStrArray;
function vbVal(cadena: string): olevariant;
function vbStr(numero: single): string;
function vbRight(Const Str: String; Size: Word): String;
function vbMid(Const Str: String; From, Size: Word): String;
function vbLeft(Const Str: String; Size: Word): String;
function readINI(fileName: string; section: string; ident: string;
  default: string): string;
procedure writeINI(fileName: string; section: string; ident: string; Value: string);

implementation

function vbInstr(cadena, cadbuscada: string): SizeInt;
begin
  vbInstr := Pos(cadbuscada, cadena);
end;

function vbVal(cadena: string): olevariant;
var
  r: double;
begin
  Val(cadena, r);
  vbVal := r;
end;

function vbStr(numero: single): string;
var
  s: WideString;
begin
  Str(numero, s);
  vbStr := s;
end;

function vbSplit(S: string; Delimiter: char): TStrArray;
var
  C: integer;
begin
  SetLength(Result, 0);
  repeat
    SetLength(Result, Length(Result) + 1);
    C := Pos(Delimiter, S);
    if C = 0 then
      C := Length(S) + 1;
    Result[Length(Result) - 1] := Copy(S, 1, C - 1);
    Delete(S, 1, C);
  until Length(S) = 0;
end;

function vbRight(Const Str: String; Size: Word): String;
begin
  if Size > Length(Str) then Size := Length(Str) ;
  vbRight := Copy(Str, Length(Str)-Size+1, Size)
end;

function vbMid(Const Str: String; From, Size: Word): String;
begin
  vbMid := Copy(Str, From, Size)
end;

function vbLeft(Const Str: String; Size: Word): String;
begin
  vbLeft:= Copy(Str, 1, Size)
end;

procedure writeINI(fileName: string; section: string; ident: string; Value: string);
var
  ini: TINIfile;
begin
  ini := TINIfile.Create(filename);
  try
    ini.WriteString(section, ident, Value);
  finally
    // ini.Free;
    FreeAndNil(ini);
  end;
end;

function readINI(fileName: string; section: string; ident: string;
  default: string): string;
var
  ini: TINIfile;
begin
  ini := TINIfile.Create(filename);
  try
    Result := ini.ReadString(section, ident, default);
  finally
    // ini.Free;
    FreeAndNil(ini);
  end;
end;

end.
